#define SVR_INTERNAL_ACCESS
#include "svr.h"
#include "thr_act.h"
#include <mysql.h>
#include <netinet/tcp.h>
#include <strings.h>
#include <fcntl.h>

type_queue  * send_que=NULL;
int sendQuedone 		= 0;
int tUsercnt			= 0;
int signal_sock_no	= 0;

pthread_mutex_t 		sendQuelock = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t			sendQuecond	= PTHREAD_COND_INITIALIZER;
pthread_mutex_t 		synclock	= PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t			synccond	= PTHREAD_COND_INITIALIZER;

typedef struct sockPair{
	int tcpSock;
	int udpSock;
} type_sockpair;

void peer_die(){
	signal_sock_no=-2;
	printf("NO DESCRIPTER TO WRITE ERROR\n");
	return;
}

extern int svr_ret_tot(){
	return tUsercnt;
}

static void setup_signals(void)
{
	struct sigaction    sa;

	sa.sa_handler = peer_die;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = 0;
	if (sigaction(SIGPIPE, &sa, NULL) == -1) {
		perror("sigaction(SIGPIPE)");
		exit(1);
	}
	return;
}

int main(){

	int 				tcpsock,udpsock,tresult;
	struct 			sockaddr_in	laddr,udservaddr;
	struct 			linger ling = { 1, 0 };
	type_sockpair 	sockPair;
	pthread_t      thread_id[4];
	pthread_attr_t attr;
	const int val=1;
	if ((tcpsock = socket(PF_INET,SOCK_STREAM,0))<0)
	{
		printf("error in sock \n");
		return -1;
	}
	
	if ((udpsock = socket(PF_INET,SOCK_DGRAM,0))<0)
	{
		printf("error in udpsock \n");
		return -1;
	}
	
	if (setsockopt(tcpsock,SOL_SOCKET,SO_REUSEADDR,&val,sizeof(int))<0)
		printf("error in sockopt1 \n");
	
	if (setsockopt(tcpsock,SOL_SOCKET,SO_KEEPALIVE,&val,sizeof(int))<0)
		printf("error in sockopt3 \n");
	
	if (setsockopt(tcpsock, SOL_SOCKET, SO_LINGER, (char *) &ling, sizeof(struct linger)) < 0)
		printf("[initialize_communication()] can't setsockopt(SO_LINGER)\n");
	
	memset(&laddr,0,sizeof(laddr));
	laddr.sin_family = AF_INET;
	laddr.sin_port = htons((unsigned short)_G_TCP_PORT);
	laddr.sin_addr.s_addr =	htonl(INADDR_ANY);
	
	bzero(&udservaddr, sizeof(udservaddr));
	udservaddr.sin_family      = AF_INET;
	udservaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	udservaddr.sin_port        = htons((unsigned short)_G_UDP_PORT);
	
	if (bind(udpsock,(struct sockaddr *)&udservaddr, sizeof(udservaddr))<0)
	{
		printf("error in bind udp\n");
		close(tcpsock);
		return -1;
	}
	
	if (bind(tcpsock,(struct sockaddr *)&laddr,sizeof(laddr))<0)
	{
		printf("error in bind \n");
		close(tcpsock);
		return -1;
	}
	if (fcntl(tcpsock, F_SETFL, O_NONBLOCK) == -1) {
		printf("error in fcntl \n");
		close(tcpsock);
		return -1;
	}
	
	if (listen(tcpsock,LISTEN_QUEUE)<0)
	{
		printf("error in listen \n");
		close(tcpsock);
		return -1;
	}
	sockPair.tcpSock = tcpsock;
	sockPair.udpSock = udpsock;
	
	pthread_attr_init(&attr);
	pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
	
	init_t_sessionArray();//ZbVCfbNX
	setup_signals();//set up signals
	
	tresult = pthread_create(&thread_id[0], &attr, Thread_sendpack, NULL);
	if(tresult!=0) printf("thread creation failed %d \n",tresult);
	tresult = pthread_create(&thread_id[1], &attr, Thread_sync, NULL);
	if(tresult!=0) printf("thread creation failed %d \n",tresult);
	tresult = pthread_create(&thread_id[2], &attr, Thread_recvpack, &sockPair);
	if(tresult!=0) printf("thread creation failed %d \n",tresult);
	tresult = pthread_create(&thread_id[3], &attr, Thread_udpserv, &udpsock);
	if(tresult!=0) printf("thread creation failed %d \n",tresult);
	for(;;)
	pause();
	
	close(tcpsock);
	
	return 0;
}

void * Thread_recvpack(void *arg){

	int tcpsock;
	unsigned char msg[MAX_PACKET_SIZE],msgto[32][MAX_PACKET_SIZE];
	int		highest_fd;
	int		csocket,pCnt,mx;
	int		n;
	short	rPsize[8];

	type_sockpair sockPair;
	unsigned short	rEnd;
	unsigned short	nEnd = PEND;
	fd_set	rfds, efds;
	int divIdx,sizee;

	int state;
	MYSQL * conn;
	MYSQL mysql;
	type_session *		   c;
	type_session *		   nc;

	sockPair =  *((type_sockpair *)arg);
	tcpsock = sockPair.tcpSock;

	conn = mysql_real_connect(&mysql, _DBSERV, _DBID, _DBPASS,_DBDB,3306,NULL,0);
	if( conn == NULL ) {
		printf(mysql_error(&mysql));
		return NULL;
	}

	for(;;)
	{
		FD_ZERO(&rfds);
		FD_ZERO(&efds);
		highest_fd = tcpsock;
		FD_SET(tcpsock,&rfds);
		for(nc=ret_session_first2(tUsercnt);nc;nc=ret_session_next2(tUsercnt)){

			csocket = nc->sock;
			FD_SET(csocket,&rfds);
			FD_SET(csocket,&efds);//extra receive

			if (csocket>highest_fd)
				highest_fd = csocket;
		}

		if (select(highest_fd+1,&rfds,NULL,&efds,(struct timeval *)0)<0)
		{
			if (errno!=EINTR)
			continue;
		}

		/* incoming	connection (if select return new conn)*/
		if (FD_ISSET(tcpsock,&rfds))
		{
			int				    	asock;
			struct sockaddr_in 	caddr;
			unsigned int			caddr_len;

			/* accept the connection */
			caddr_len =	sizeof(caddr);
			if ((asock = accept(tcpsock,(struct sockaddr *)&caddr,&caddr_len))<0)
			{
	            if (errno == EINTR)
	                continue;
	            else
						printf("error with accept\n");
				continue;
			}else{

			}

			if (fcntl(asock,F_SETFL,O_NONBLOCK)<0)
			{
				printf("error with fcntl\n");
				shutdown(asock,2);
				close(asock);
				continue;
			}

			pthread_mutex_lock(&synclock);
			if (!(c	= session_create(asock,ntohl(caddr.sin_addr.s_addr),ntohs(caddr.sin_port))))
			{
				printf("error with session create\n");
				pthread_mutex_unlock(&synclock);//dv..
				shutdown(asock,2);
				close(asock);
				continue;
			}
			pthread_mutex_unlock(&synclock);
			tUsercnt++;
		}

		for(c=ret_session_first2(tUsercnt);c;c=ret_session_next2(tUsercnt))
		{
			if (c->state==conn_state_destroy)
			{
				tUsercnt--;
				printf("abrut disconnectss\n");
				pthread_mutex_lock(&synclock);
				session_clear(c);
				pthread_mutex_unlock(&synclock);
				continue;
			}

			csocket = c->sock;
			if (FD_ISSET(csocket,&rfds))
			{
				memset(msg,0,sizeof(msg));
				if((sizee = recv(csocket, msg, sizeof(msg), 0))<=0){//abrupt disconnect
					printf("abrut disconnect in receive\n");
					tUsercnt--;
					pthread_mutex_lock(&synclock);
					session_clear(c);
					pthread_mutex_unlock(&synclock);
					continue;
				}
				memcpy(&rPsize[0],&msg[0],2);
				pCnt=0;//packet count reset
				//check packet validity
				if(rPsize[0]==sizee){
					memcpy(&rEnd,&msg[rPsize[0] -2],2);
					if(rEnd != nEnd){
						printf("pPbgG[..\n");
						continue;
					}
					pCnt+=1;
				}else if(rPsize[0]<sizee){
					divIdx=0;
					mx=0;
					for(;;){
						if(divIdx>=sizee) break;
						memcpy(&rPsize[pCnt],&msg[divIdx],2);
						memset(msgto[pCnt],0,MAX_PACKET_SIZE);
						memcpy(&msgto[pCnt][0],&msg[divIdx],rPsize[pCnt]);
						memcpy(&rEnd,&msgto[pCnt][rPsize[pCnt] -2],2);
						if(rEnd != nEnd){
							printf("pPbgG[..(ĂpPbgO̕JbgG[..)\n");
							break;
						}else{
							mx+=rPsize[pCnt];
							pCnt+=1;
							divIdx=mx;
						}
					}
				}else continue;
				if(pCnt==1){
					if (c->state==conn_state_empty){
						state = thr_beforeAuth(msg,c,conn,sockPair.udpSock);
						if(state==0){
							printf("[U)LN^[[fBOs\n");
							c->state = conn_state_destroy;
							continue;
						}
					}else if(c->state==conn_state_authed){
						state = main_act(msg,rPsize[0],c,conn,sockPair.udpSock);
						if(state==0){
							printf("[UߏG[\n");
							//c->state = conn_state_destroy;
							continue;
						}
					}else continue;
				}else{
					for(n=0;n<pCnt;n++){
						if (c->state==conn_state_empty){
							state = thr_beforeAuth(msgto[n],c,conn,sockPair.udpSock);
							if(state==0){
								printf("[ULN^[[fBOs \n");
								c->state = conn_state_destroy;
								continue;
							}
						}else if(c->state==conn_state_authed){
							state = main_act(msgto[n],rPsize[n],c,conn,sockPair.udpSock);
							if(state==0){
								printf("[UߏG[\n");
								//c->state = conn_state_destroy;
								continue;
							}
						}else continue;
					}
				}
			}//if (FD_ISSET(csocket,&rfds)) end ڑ̃pPbgM

			if (FD_ISSET(csocket,&efds))
			{
				printf("abrut disconnect in efds\n");
				tUsercnt--;
				//sizee = db_save_all(c->character,c->userid,conn);
				if(sizee==1) printf("DISCONNECT DATA SAVE OKOKOKOKOKOK\n");
				else  printf("DISCONNECT DATA SAVE FALSEFALSEFALSEFALSE\n");
				//thr_chat_userExit(sockPair.udpSock,c);
				pthread_mutex_lock(&synclock);
				session_clear(c);
				pthread_mutex_unlock(&synclock);
			}
		}//end for linked list search loop
	}//end enless loop
	mysql_close(conn);
}


void * Thread_sendpack(void *arg)
{
	int i,j,ERRkey;
	int rets,tmp_sock;
	type_packet *	 packet;
	type_session * c;
	type_session * ERRmap[16];
	type_session * tmp;
	int que_len;

	for(i=0;i<16;i++)
		ERRmap[i]=NULL;

	for(;;){
		ERRkey=0;
		pthread_mutex_lock(&sendQuelock);
		que_len = queue_get_length((type_queue const	* const	*)&send_que);
		while(que_len==0){
			pthread_cond_wait(&sendQuecond,&sendQuelock);
			que_len = queue_get_length((type_queue const	* const	*)&send_que);
		}
		packet = queue_pull_packet(&send_que);
		i=0;
		while(i<que_len){
			i+=1;

			c = (type_session *)packet->session;
			tmp_sock = c->sock;

			if(!packet->session){
				printf("ZbVnull.........................\n");
				packet_destroy(packet);
				if(i<que_len) packet = queue_pull_packet(&send_que);

			}else if(tmp_sock==-2){
				printf("svr.c 649ňُ sigpipe .........................\n");
				packet_destroy(packet);
				if(i<que_len) packet = queue_pull_packet(&send_que);
			}else{
					if(packet->size<5){
						printf("Send error pPbg̒T菬...%d\n",packet->data[2]);
					}else{
						rets = send(packet->cli_sock, packet->data, packet->size,0);
						if(rets<=0){
							printf("send errorsss\n");
							ERRmap[ERRkey]=c;
							ERRkey+=1;
						}
					}
					packet_destroy(packet);
					if(i<que_len) packet = queue_pull_packet(&send_que);
			}
		}//end while
		pthread_mutex_unlock(&sendQuelock);

		if(ERRkey!=0){
			pthread_mutex_lock(&synclock);
			for(j=0;j<ERRkey;j++){
				ERRmap[j]->sock= signal_sock_no;
				ERRmap[j]->state = conn_state_destroy;
				tmp=ERRmap[j];
				ERRmap[j]=NULL;
			}
			pthread_mutex_unlock(&synclock);
		}
	}
}

void * Thread_udpserv(void *arg){

	int udpsock,n;
	fd_set	rfds;
	int highest_fd;
	socklen_t	len;
	struct	sockaddr_in cliaddr;
	int SVRchk;

	char msg[64];
	char temp[1];
	short pLen;
	type_cmdsec		cur_sec;
	int i;
	unsigned short	rEnd;
	unsigned short	nEnd = PEND;

	udpsock = *((int *)arg);

	while(1) {
		SVRchk=0;
		FD_ZERO(&rfds);
		highest_fd = udpsock;
		FD_SET(udpsock,&rfds);
		len = sizeof(cliaddr);
		select(highest_fd+1,&rfds,NULL,NULL,0);

		if (FD_ISSET(udpsock,&rfds)){
			memset(msg,0,64);
			n = recvfrom(udpsock, msg, 64, 0,(struct sockaddr *)&cliaddr, &len);
			memcpy(&pLen,&msg[0],2);
			if(n!=(int)pLen){
				printf("UDP invalid udp packet rev pPbg̒Ⴄ.\n");
				continue;
			}
			if(n<5) continue;
			memcpy(&rEnd,&msg[n-2],2);
			if(rEnd != nEnd){
				printf("UDP pPbgG[..\n");
				continue;//pPbgG[..
			}
			memcpy(&temp[0],&msg[2],1);//get head
			switch(temp[0]){
				case 0:
					printf("[_SVR_REQ_USERLIST]\n");
				break;

				default:
					printf("invalid packet rcv\n");
					for(i = 0 ; i < n ; i++) printf("msg[%d] %d\n", i, msg[i]);
					continue;
			}
			set_sec_only_time(&cur_sec);
		}
	}
}

