#include "ObjectList.h"
#include <assert.h>

BOOL ObjectList::add_node_objlist(pptype_objlist objlist, void *	data)
{
	void *m_pMemBlock;
	if (!objlist)
		return FALSE;
	
    const int AllocationSize=sizeof(type_objlist); // ̑傫
    m_pMemBlock=VirtualAlloc(NULL,AllocationSize,MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	assert(m_pMemBlock);

	ptype_objlist node=reinterpret_cast<type_objlist*>(m_pMemBlock);

	node->data = data;
	node->next = *objlist;
	*objlist = node;
	return TRUE;
}


pptype_objlist ObjectList::find_node_objlist(pptype_objlist objlist, void *	data)
{
	pptype_objlist tmps;
	if (!objlist)
		return NULL;
	if (!*objlist)
		return NULL;
	tmps = objlist;
	if ((*tmps)->data==data)
		return tmps;
	while ((*tmps)->next && (*tmps)->next->data!=data)
		tmps = &(*tmps)->next;
	if ((*tmps)->next)
		return &(*tmps)->next;
	return NULL;
}


BOOL ObjectList::rm_objlist(pptype_objlist objlist)
{
	ptype_objlist tmps;

	if (!objlist)
		return FALSE;
	tmps = *objlist;
	if (!tmps)
		return FALSE;

	*objlist = (*objlist)->next;
	if(tmps)
	{
		VirtualFree(tmps,0,MEM_RELEASE);
	}
	
	return TRUE;
}


void * ObjectList::get_node_objlist(type_objlist const * objlist)
{
	if (!objlist)
		return NULL;
	return objlist->data;
}


type_objlist const * const * ObjectList::get_next_node_objlist_const(type_objlist const * objlist)
{
	if (!objlist)
		return NULL;
	return (type_objlist const * const *)&objlist->next;
}


ptype_objlist ObjectList::pop_data(pptype_objlist objlist)
{
	ptype_objlist  tmps;
	if (!objlist)
		return NULL;
	tmps = *objlist;
	if (!tmps)
		return NULL;
	*objlist = (*objlist)->next;
	return tmps;
}


int ObjectList::insert_node_objlist(pptype_objlist target_objlist, ptype_objlist source_objlist)
{

	if (!target_objlist)
		return FALSE;
	if (!source_objlist)
		return FALSE;
	source_objlist->next = *target_objlist;
	*target_objlist = source_objlist;
	return TRUE;
}
