#include "database.h"
#include <assert.h>


Databases::Databases(void){
	int i;
	BOOL ret=InitDatabase();
	if(ret==FALSE){
		printf("Database init failed\n");
	}
	InitializeCriticalSection(&d_cs);
	cirQueLen=getPos=putPos=0;
	overPos=-1;
	for(i=0;i<CIRQUE_SIZE;i++){//circular queue init
		if(CIRQUE_SIZE==i+1){
			DBcircQue[i].next=&DBcircQue[0];
		}else DBcircQue[i].next=&DBcircQue[i+1];
		DBcircQue[i].index=i;
	}
	InitMap();
}


BOOL Databases::InitDatabase(void){
	
	if ( (mydata = mysql_init((MYSQL*) 0)) && mysql_real_connect( mydata, 
				"localhost", "mitierra", "1234", NULL, MYSQL_PORT, NULL, 0 ) )
	{
		if ( mysql_select_db( mydata, "mmo" ) < 0 ) {
			printf( "Can't select the mmo database !\n") ;
			mysql_close( mydata ) ;
			return FALSE;
		}
		else
		{
			printf("ڑ܂.\n");
		}

		/* databasef[^̏*/
		LoadItemList();	//ACe\[Xǉ
		LoadExpList();	//olxe[u
		LoadNpcList();	//npcXg
		LoadSkillList();
		LoadSvrList();
	
	}else return FALSE;
	return TRUE;
}


BOOL Databases::InitMap(void){

	FILE * fp;
	DWORD mxtileno,i,x,y;
	BYTE val;

	fp = fopen (MAP_FILE,"r");
	if (fp == NULL){
		printf ("file Open error\n");
		return FALSE;
	}

	fread(&mxtileno, 4 , 1 , fp);
	for(i=0; i<mxtileno; i++)
	{
		fread(&val,1,1,fp);//0:use 1:monster 2:npc 3:not use
		x = i%M_SIZE_X;//x W
		y = i/M_SIZE_X;//z W
		if(val==0) m_Map.map[x][y]=0;
		else if(val>9&&val<100){
//printf("monster load no:%d\n",val);
			m_Npc.NpcDataSet(2,val,x,y);
			m_Map.map[x][y]=0;
		}else if(val>99){
//printf("npc load no:%d\n",val);
			m_Npc.NpcDataSet(1,val,x,y);
			m_Map.map[x][y]=0;
		}else m_Map.map[x][y]=1;//Ȃ..
	}
	return TRUE;
}



BOOL Databases::EnqueQry(char * qry){

	int state;

	EnterCriticalSection(&d_cs);

	if(overPos==DBcircQue[putPos].index){//queue full
		LeaveCriticalSection(&d_cs);
		state = mysql_query(mydata, qry);//ۑ
		return state;
	}
	memset(DBcircQue[putPos].query,0,1024);
	sprintf(DBcircQue[putPos].query,"%s",qry);

	cirQueLen+=1;//L[m[hɃf[^ǉ
	putPos=DBcircQue[putPos].next->index;//ɓ͂ƂL[̃CfbNX

	LeaveCriticalSection(&d_cs);
	return 1;
}


BOOL Databases::UserAuth(char * userid, char * passwd, WORD passlen,Ptype_session pPerSocketCtx){

	int	state;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char query[256];

	assert(userid!=NULL);
	assert(passwd!=NULL);

	memset(query,0,256);
	sprintf(query,"select count(*) from userinfo where userid='%s' and passwd='%s'",userid,passwd);
printf("DBUG1\n");
	state = mysql_query(mydata,query);
	if( state == -1 ) {
		printf("testXX%s\n",mysql_error(mydata));
		return FALSE;
	}
	result = mysql_store_result(mydata);
	state = mysql_num_rows(result);
	if( state == 0 ) {
		printf("mysql fail return value 0 \n");
		mysql_free_result(result);
		return FALSE;
	}

	row = mysql_fetch_row(result);
	state=atoi(row[0]);
printf("DBUG2 res:%d\n",state);
	mysql_free_result(result);
	if(state==1){
		memset(query,0,256);
		sprintf(query,"select * from characters where userid='%s'",userid);

		state = mysql_query(mydata, query);
		if( state == -1 ) {
			printf("1testXX%s\n",mysql_error(mydata));
			return FALSE;
		}
printf("DBUG3\n");

		result = mysql_store_result(mydata);
		state = mysql_num_rows(result);
		if( state == 0 ) {
			printf("2mysql fail return value 0 \n");
			mysql_free_result(result);
			return FALSE;
		}
		pPerSocketCtx->state=conn_state_authed;
printf("DBUG4\n");

		row = mysql_fetch_row(result);
printf("DBUG5\n");
		pPerSocketCtx->uLen			=strlen(row[0]);						//userid length
		memcpy(&pPerSocketCtx->userid[0],&row[0][0],pPerSocketCtx->uLen);	//NAME
		pPerSocketCtx->nLen			=strlen(row[1]);						//char name length
		memcpy(&pPerSocketCtx->char_name[0],&row[1][0],pPerSocketCtx->nLen);//NAME

		pPerSocketCtx->race			=atoi(row[2]);	//RACE
		pPerSocketCtx->sex			=atoi(row[3]);	//SEX
		pPerSocketCtx->nation		=atoi(row[4]);	//NATION

		pPerSocketCtx->str			=atoi(row[5]);	//STR
		pPerSocketCtx->dex			=atoi(row[6]);	//DEX
		pPerSocketCtx->intel		=atoi(row[7]);	//INT

		pPerSocketCtx->mana_c		=atoi(row[8]);	//MANA
		pPerSocketCtx->hp_c			=atoi(row[9]);	//HP
		pPerSocketCtx->exp			=atoi(row[10]); //EXP
		pPerSocketCtx->level		=atoi(row[11]);	//LV
		pPerSocketCtx->lvpoint		=atoi(row[12]);	//PT
		pPerSocketCtx->skexp		=atoi(row[13]);	//PT

		pPerSocketCtx->jobno		=atoi(row[14]);	//JOB
		pPerSocketCtx->classno		=atoi(row[15]);	//CLASS
		pPerSocketCtx->classlevel	=atoi(row[16]);	//CLASSLV
		pPerSocketCtx->worldmap		=atoi(row[17]);	//LOC_SVR
		pPerSocketCtx->Cx			=atoi(row[18]);	//LOCX
		pPerSocketCtx->Cy			=atoi(row[19]);	//LOCy
		pPerSocketCtx->Ax			=pPerSocketCtx->Cx/S_UNITSIZE;
		pPerSocketCtx->Ay			=pPerSocketCtx->Cy/S_UNITSIZE;
		pPerSocketCtx->Bx			=pPerSocketCtx->Ax;
		pPerSocketCtx->By			=pPerSocketCtx->Ay;

		pPerSocketCtx->eq[0]		=atoi(row[20]);	//I_HEAD
		pPerSocketCtx->eq[1]		=atoi(row[21]);	//I_L_HAND
		pPerSocketCtx->eq[2]		=atoi(row[22]);	//I_R_HAND
		pPerSocketCtx->eq[3]		=atoi(row[23]);	//I_BODY
		pPerSocketCtx->eq[4]		=atoi(row[24]);	//I_LEG
		pPerSocketCtx->eq[5]		=atoi(row[25]);	//I_NECKLACE
		pPerSocketCtx->eq[6]		=atoi(row[26]);	//I_RING1
		pPerSocketCtx->coin			=atoi(row[27]);	//COIN
		mysql_free_result(result);

		memset(query,0,256);
		sprintf(query,"select * from useritem where userid='%s'",userid);
printf("DBUG6\n");

		state = mysql_query(mydata, query);
		if( state == -1 ) {
			printf("3testXX%s\n",mysql_error(mydata));
			return FALSE;
		}
		result = mysql_store_result(mydata);
		state = mysql_num_rows(result);
		if( state == 0 ) {
			printf("4mysql fail return value 0 \n");
			mysql_free_result(result);
			return FALSE;
		}
		row = mysql_fetch_row(result);
		pPerSocketCtx->inven[0]				=atoi(row[2]);
		pPerSocketCtx->inven_cnt[0]			=atoi(row[3]);
		pPerSocketCtx->inven[1]				=atoi(row[4]);
		pPerSocketCtx->inven_cnt[1]			=atoi(row[5]);
		pPerSocketCtx->inven[2]				=atoi(row[6]);
		pPerSocketCtx->inven_cnt[2]			=atoi(row[7]);
		pPerSocketCtx->inven[3]				=atoi(row[8]);
		pPerSocketCtx->inven_cnt[3]			=atoi(row[9]);
		mysql_free_result(result);
printf("DBUG7\n");

		memset(query,0,256);
		sprintf(query,"select * from skill where userid='%s'",userid);

		state = mysql_query(mydata, query);
		if( state == -1 ) {
			printf("5testXX%s\n",mysql_error(mydata));
			return FALSE;
		}
		result = mysql_store_result(mydata);
		state = mysql_num_rows(result);
		if( state == 0 ) {
			printf("6mysql fail return value 0 \n");
			mysql_free_result(result);
			return FALSE;
		}
		row = mysql_fetch_row(result);
		pPerSocketCtx->skill[0]				=atoi(row[2]);
		pPerSocketCtx->skill_lv[0]			=atoi(row[3]);
		pPerSocketCtx->skill[1]				=atoi(row[4]);
		pPerSocketCtx->skill_lv[1]			=atoi(row[5]);
		pPerSocketCtx->skill[2]				=atoi(row[6]);
		pPerSocketCtx->skill_lv[2]			=atoi(row[7]);
		pPerSocketCtx->skill[3]				=atoi(row[8]);
		pPerSocketCtx->skill_lv[3]			=atoi(row[9]);
		mysql_free_result(result);
printf("DBUG8\n");

		memset(query,0,256);
		sprintf(query,"select * from warehouse where userid='%s'",userid);

		state = mysql_query(mydata, query);
		if( state == -1 ) {
			printf("7testXX%s\n",mysql_error(mydata));
			return FALSE;
		}
		result = mysql_store_result(mydata);
		state = mysql_num_rows(result);
		if( state == 0 ) {
			printf("8mysql fail return value 0 \n");
			mysql_free_result(result);
			return FALSE;
		}
		row = mysql_fetch_row(result);
		pPerSocketCtx->ware[0]				=atoi(row[1]);
		pPerSocketCtx->ware_cnt[0]			=atoi(row[2]);
		pPerSocketCtx->ware[1]				=atoi(row[3]);
		pPerSocketCtx->ware_cnt[1]			=atoi(row[4]);
		pPerSocketCtx->ware[2]				=atoi(row[5]);
		pPerSocketCtx->ware_cnt[2]			=atoi(row[6]);
		pPerSocketCtx->ware[3]				=atoi(row[7]);
		pPerSocketCtx->ware_cnt[3]			=atoi(row[8]);
		pPerSocketCtx->ware[4]				=atoi(row[9]);
		pPerSocketCtx->ware_cnt[4]			=atoi(row[10]);
		pPerSocketCtx->ware[5]				=atoi(row[11]);
		pPerSocketCtx->ware_cnt[5]			=atoi(row[12]);
		pPerSocketCtx->ware[6]				=atoi(row[13]);
		pPerSocketCtx->ware_cnt[6]			=atoi(row[14]);
		pPerSocketCtx->ware[7]				=atoi(row[15]);
		pPerSocketCtx->ware_cnt[7]			=atoi(row[16]);
		mysql_free_result(result);

		pPerSocketCtx->mana_F_cnt			=0;// i}񕜗pJE^..
		pPerSocketCtx->recov_F_cnt			=0;// q[[񕜗pJE^..
		pPerSocketCtx->attack_F_cnt			=0;// q[[UxpJE^..
		pPerSocketCtx->regen_F_cnt			=0;// [WFJE^
		pPerSocketCtx->dbSaveCnt			=0;// f[^ۑJE^
		pPerSocketCtx->move_F_cnt			=0;

		pPerSocketCtx->party.flag			=0;// p[eBtbO
		pPerSocketCtx->party.waitfor		=NULL;// ҋ@̐l
		pPerSocketCtx->party.cnt			=0;// ҋ@̐l
		pPerSocketCtx->party.memidx			=0;	// ̈ʒu
		pPerSocketCtx->party.infoFcnt		=0;	//[UʒmJEg..
		pPerSocketCtx->party.ison1			=0;	//0:NULL 	1:linked		2:myself(member#==NULL)
		pPerSocketCtx->party.ison2			=0;
		pPerSocketCtx->party.ison3			=0;

		pPerSocketCtx->trade.flag			=0;// tbO
		pPerSocketCtx->moveLevel			=2;
		pPerSocketCtx->pkmode				=0;//player kill mode default off:0 on:1
		//vZœl..
/*		pPerSocketCtx->attack	= pPerSocketCtx->str+pPerSocketCtx->dex+pPerSocketCtx->intel+pPerSocketCtx->level
								+item_get_attack(pPerSocketCtx->eq[1])+item_get_attack(pPerSocketCtx->eq[2]);//ǉ
*/
		pPerSocketCtx->hp_m 				=pPerSocketCtx->str + pPerSocketCtx->dex+50;
		pPerSocketCtx->mana_m				=pPerSocketCtx->intel + 50;
/*		pPerSocketCtx->defence	=item_get_defence(pPerSocketCtx->eq[0])
									+item_get_defence(pPerSocketCtx->eq[1])
									+item_get_defence(pPerSocketCtx->eq[2])
									+item_get_defence(pPerSocketCtx->eq[3])
									+item_get_defence(pPerSocketCtx->eq[4])
									+item_get_defence(pPerSocketCtx->eq[5])
									+item_get_defence(pPerSocketCtx->eq[6]);
*/
		pPerSocketCtx->dbLoaded =1;
printf("DBUG9\n");	
	}else return FALSE;
printf("DBUG10\n");
//	
	return TRUE;
}


void Databases::LoadItemList(void)
{
	int	state,cnt=0;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char query[256];

	memset(query,0,256);
	sprintf(query,"select * from ITEM");

	state = mysql_query(mydata, query);
	if( state == -1 ) {
		printf("db_load_itemList:%s\n",mysql_error(mydata));
		return ;
	}
	result = mysql_store_result(mydata);
	state = mysql_num_rows(result);
	if( state == 0 ) {
		printf("db no item list found0 \n");
		mysql_free_result(result);
		return ;
	}

	while((row = mysql_fetch_row(result))!= NULL){
		cnt++;
		m_Item.ItemLoad(row);//row PʂŃXgɒǉ..
	}
	printf("ACev %d[h\n",cnt);
	mysql_free_result(result);

}


void Databases::LoadExpList(void)
{
	int	state,lv;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char query[256];

//	item_init();
	memset(query,0,256);
	sprintf(query,"select * from expp order by lv asc");

	state = mysql_query(mydata, query);
	if( state == -1 ) {
		printf("db_load_expList:%s\n",mysql_error(mydata));
		return ;
	}
	result = mysql_store_result(mydata);
	state = mysql_num_rows(result);
	if( state == 0 ) {
		printf("db no exp list found0 \n");
		mysql_free_result(result);
		return ;
	}
	while((row = mysql_fetch_row(result))!= NULL){
		lv=atoi(row[0]);
		exp_list[lv]=atoi(row[1]);
		printf("x%d͌v%ďolȂ%dɃxAbvłȂ\n",lv,exp_list[lv],lv+1);
	}
	mysql_free_result(result);

}


void Databases::LoadNpcList(void)//
{	
	MYSQL_RES *result;
	MYSQL_ROW row;
	int	state,i;
	char query[256],rate[12];
	char no,div,level,gtype,speed;
	short item[12];

	memset(query,0,256);
	sprintf(query,"select * from npc");

	state = mysql_query(mydata, query);
	if( state == -1 ) {
		printf("db_load_npcList:%s\n",mysql_error(mydata));
		return ;
	}
	result = mysql_store_result(mydata);
	state = mysql_num_rows(result);
	if( state == 0 ) {
		printf("db no npc list found0 \n");
		mysql_free_result(result);
		return ;
	}
	while((row = mysql_fetch_row(result))!= NULL){
		div=atoi(row[0]);
		no=atoi(row[1]);
		gtype=atoi(row[2]);
		level=atoi(row[3]);
		speed=atoi(row[4]);
		for(i=0;i<12;i++){
			item[i]=atoi(row[5+i]);
			rate[i]=atoi(row[17+i]);
		}

		m_Npc.NpcSetDef(div,no,gtype,level,speed,item,rate);
		if(div==0) printf("NPC load no:%d	gtype:%d	level:%d	speed:%d\n",no,gtype,level,speed);
		else printf("MONSTER load no:%d	gtype:%d	level:%d	speed:%d\n",no,gtype,level,speed);
	}
	mysql_free_result(result);
}


BOOL Databases::LevelUpCheck(Ptype_session pPerSocketCtx)
{
	int state;
	char query[256];

	memset(query,0,256);
	if(pPerSocketCtx->level>MAXUSERLEVEL||pPerSocketCtx->level==0) return FALSE;
	if(exp_list[pPerSocketCtx->level]<=pPerSocketCtx->exp){
		pPerSocketCtx->level+=1;
		pPerSocketCtx->lvpoint+=1;

		sprintf(query,"update characters set LV='%d',PT='%d' where userid='%s'",
				pPerSocketCtx->level,pPerSocketCtx->lvpoint,pPerSocketCtx->userid);
		state = mysql_query(mydata, query);
		if( state == -1 ) {
			printf("update lv & lvpoint error:%s\n",mysql_error(mydata));
			return FALSE;
		}
		return TRUE;
	}else return FALSE;
}


void Databases::LoadSkillList(void)
{
	int	sktype,coin,skidx,state,i=0;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char query[256];

	memset(query,0,256);
	sprintf(query,"select * from skilldef");

	state = mysql_query(mydata, query);
	if( state == -1 ) {
		printf("db_load_expList:%s\n",mysql_error(mydata));
		return ;
	}
	result = mysql_store_result(mydata);
	state = mysql_num_rows(result);
	if( state == 0 ) {
		printf("skill def\n");
		mysql_free_result(result);
		return ;
	}
	while((row = mysql_fetch_row(result))!= NULL){
		i++;
		sktype=atoi(row[0]);
		skidx=atoi(row[1]);
		coin=atoi(row[2]);
		m_Skill.DefSkill(sktype,skidx,row[3],row[4],coin);
	}
	mysql_free_result(result);
	printf("v%d ̃XLXg[h\n",i);
}


BOOL Databases::LoadSvrList(void)
{
	MYSQL_RES *result;
	char query[128];
	int state,idx;
	MYSQL_ROW row;

	memset(query,0,128);
	sprintf(query,"select * from SVRLIST");
	state = mysql_query(mydata, query);
	if( state == -1 ){
		return FALSE;
	}

	result = mysql_store_result(mydata);
	state = mysql_num_rows(result);

	if( state == 0 ){
		mysql_free_result(result);
		return FALSE;
	}else{

		while((row = mysql_fetch_row(result))!= NULL){
			idx = atoi(row[0]);
			worldinfo[idx].ip[0] = atoi(row[1]);
			worldinfo[idx].ip[1] = atoi(row[2]);
			worldinfo[idx].ip[2] = atoi(row[3]);
			worldinfo[idx].ip[3] = atoi(row[4]);
			worldinfo[idx].tport = atoi(row[5]);

//			bzero(&worldinfo[idx].udpSvr, sizeof(worldinfo[idx].udpSvr));
			worldinfo[idx].udpSvr.sin_family = AF_INET;
			worldinfo[idx].udpSvr.sin_port = htons(atoi(row[7]));//port
//			inet_pton(AF_INET, row[6], &worldinfo[idx].udpSvr.sin_addr);
			worldinfo[idx].udpLen = sizeof(worldinfo[idx].udpSvr);
			printf("%d.%d.%d.%d:%d loaded\n",
						worldinfo[idx].ip[0],worldinfo[idx].ip[1],worldinfo[idx].ip[2],worldinfo[idx].ip[3],worldinfo[idx].tport);
		}
	}

	mysql_free_result(result);
	return TRUE;
}


BYTE * Databases::ReturnTcpIp(int idx){

	if(idx >=MX_SVR_NO)
		return NULL;
	return worldinfo[idx].ip;
}


WORD Databases::ReturnTcpPort(int idx){
	if(idx >=MX_SVR_NO)
		return -1;
	return worldinfo[idx].tport;
}


type_sockadr * Databases::ReturnUdpSock(int idx){
	if(idx >=MX_SVR_NO)
		return NULL;
	return &worldinfo[idx].udpSvr;
}


DWORD Databases::ReturnUdpLen(int idx){
	if(idx >=MX_SVR_NO)
		return -1;
	return worldinfo[idx].udpLen;
}


BOOL Databases::SaveAll(Ptype_session pPerSocketCtx)
{
	int	state;
	char query[1024];

	if(pPerSocketCtx->dbLoaded==0) return 0;
	memset(query,0,1024);
	sprintf(query,"update characters set MANA='%d',HP='%d',EXP='%d',SKEXP='%d',CLASSLV='%d',LOC_SVR='%d',LOCX='%d',LOCY='%d',I_HEAD='%d',I_L_HAND='%d',I_R_HAND='%d',I_BODY='%d',I_LEG='%d',I_NECKLACE='%d',I_RING='%d',COIN='%d' where userid='%s'",
						pPerSocketCtx->mana_c,pPerSocketCtx->hp_c,pPerSocketCtx->exp,pPerSocketCtx->skexp,pPerSocketCtx->classlevel,pPerSocketCtx->worldmap,pPerSocketCtx->Cx,pPerSocketCtx->Cy,pPerSocketCtx->eq[0],pPerSocketCtx->eq[1],pPerSocketCtx->eq[2],pPerSocketCtx->eq[3],pPerSocketCtx->eq[4],pPerSocketCtx->eq[5],pPerSocketCtx->eq[6],pPerSocketCtx->coin,pPerSocketCtx->userid);

#ifdef _DB_QUERY_ENQUEUE
 	state = EnqueQry(query);
#else
 	state = mysql_query(mydata, query);
#endif
	if( state == -1 ) {
		printf("db_char_SAVE ALL1%s\n",mysql_error(mydata));
		return FALSE;
	}
	//printf("save query:%s\n",query);

	memset(query,0,1024);
	sprintf(query,"update skill set IDX0='%d',LV0='%d',IDX1='%d',LV1='%d',IDX2='%d',LV2='%d',IDX3='%d',LV3='%d' where USERID='%s'",
		pPerSocketCtx->skill[0],pPerSocketCtx->skill_lv[0],pPerSocketCtx->skill[1],pPerSocketCtx->skill_lv[1],pPerSocketCtx->skill[2],pPerSocketCtx->skill_lv[2],pPerSocketCtx->skill[3],pPerSocketCtx->skill_lv[3],pPerSocketCtx->userid);

#ifdef _DB_QUERY_ENQUEUE
 	state = EnqueQry(query);
#else
 	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_char_SAVE ALL2%s\n",mysql_error(mydata));
		return FALSE;
	}
	//printf("save query:%s\n",query);

	memset(query,0,1024);
	sprintf(query,"update useritem set IDX_0='%d',Q_0='%d',IDX_1='%d',Q_1='%d',IDX_2='%d',Q_2='%d',IDX_3='%d',Q_3='%d' where USERID='%s'",
		pPerSocketCtx->inven[0],pPerSocketCtx->inven_cnt[0],pPerSocketCtx->inven[1],pPerSocketCtx->inven_cnt[1],pPerSocketCtx->inven[2],pPerSocketCtx->inven_cnt[2],pPerSocketCtx->inven[3],pPerSocketCtx->inven_cnt[3],pPerSocketCtx->userid);
#ifdef _DB_QUERY_ENQUEUE
 	state = EnqueQry(query);
#else
 	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_useritem %s\n",mysql_error(mydata));
		return FALSE;
	}

	memset(query,0,1024);
	sprintf(query,"update warehouse set IDX_0=%d,Q_0=%d,IDX_1=%d,Q_1=%d,IDX_2=%d,Q_2=%d,IDX_3=%d,Q_3=%d,IDX_4=%d,Q_4=%d,IDX_5=%d,Q_5=%d,IDX_6=%d,Q_6=%d,IDX_7=%d,Q_7=%d where USERID ='%s'",
		pPerSocketCtx->ware[0],pPerSocketCtx->ware_cnt[0],pPerSocketCtx->ware[1],pPerSocketCtx->ware_cnt[1],pPerSocketCtx->ware[2],pPerSocketCtx->ware_cnt[2],pPerSocketCtx->ware[3],pPerSocketCtx->ware_cnt[3],pPerSocketCtx->ware[4],pPerSocketCtx->ware_cnt[4],pPerSocketCtx->ware[5],pPerSocketCtx->ware_cnt[5],pPerSocketCtx->ware[6],pPerSocketCtx->ware_cnt[6],pPerSocketCtx->ware[7],pPerSocketCtx->ware_cnt[7],pPerSocketCtx->userid);
#ifdef _DB_QUERY_ENQUEUE
 	state = EnqueQry(query);
#else
 	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_TB_HOSE %s\n",mysql_error(mydata));
		return FALSE;
	}

	printf("save query:%s\n",query);
	return TRUE;
}






BOOL Databases::ItemPick(Ptype_session pPerSocketCtx, WORD invidx)
{//EÂĂA@ׂē..
	int	state;
	char query[1024];

	memset(query,0,1024);

	sprintf(query,"update useritem set IDX_%d=%d,Q_%d=%d where USERID='%s' and NAME='%s'",
			invidx,pPerSocketCtx->inven[invidx],invidx,pPerSocketCtx->inven_cnt[invidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_pick ERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	return 1;
}



BOOL Databases::ItemDrop(Ptype_session pPerSocketCtx, WORD invidx)
{//EÂĂA@ׂē..
	int	state;
	char query[1024];

	memset(query,0,1024);

	sprintf(query,"update useritem set IDX_%d=%d,Q_%d=%d where USERID='%s' and NAME='%s'",
			invidx,pPerSocketCtx->inven[invidx],invidx,pPerSocketCtx->inven_cnt[invidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_drop ERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	return 1;
}

BOOL Databases::ItemBuy(Ptype_session pPerSocketCtx, WORD invidx)
{// EÂĂA@ׂē..
	int	state;
	char query[1024];

	memset(query,0,1024);
	sprintf(query,"update useritem set IDX_%d=%d,Q_%d=%d where USERID='%s' and NAME='%s'",
				invidx,pPerSocketCtx->inven[invidx],invidx,pPerSocketCtx->inven_cnt[invidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_pick 1ERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	sprintf(query,"update characters set coin=%d where USERID='%s' and NAME='%s'",
				pPerSocketCtx->coin,pPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_buy 2ERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	return 1;
}

BOOL Databases::ItemSell(Ptype_session pPerSocketCtx, char * data)
{
	int	state;
	char query[1024];
	int tot,invenidx,i,j;

	memset(query,0,1024);
	tot = data[5];
	sprintf(query,"update useritem set");
	for(i=0,j=4;i<tot;i++){
		invenidx=data[j];
		j+=2;
		if(i==0){
			 sprintf(query,"%s IDX_%d=%d,Q_%d=%d",
					query,invenidx,pPerSocketCtx->inven[invenidx],invenidx,pPerSocketCtx->inven_cnt[invenidx]);
		}else{
			sprintf(query,"%s ,IDX_%d=%d,Q_%d=%d",
					query,invenidx,pPerSocketCtx->inven[invenidx],invenidx,pPerSocketCtx->inven_cnt[invenidx]);//R}ǉ
		}
		
	}

	sprintf(query,"%s where USERID='%s' and NAME='%s'",query,pPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_sell 1ERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	memset(query,0,1024);
	sprintf(query,"update characters set coin=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->coin,pPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_sell 2ERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	return 1;
}


BOOL Databases::ItemTrade(Ptype_session pPerSocketCtx, 
							  Ptype_session tpPerSocketCtx, char * sChange, char * tChange)
{
	int	state;
	char squery[1024],tquery[1024];
	int i,schk=0,tchk=0;

	memset(squery,0,1024);
	memset(tquery,0,1024);

	sprintf(squery,"update useritem set");
	sprintf(tquery,"update useritem set");

	for(i=0;i<4;i++){
		if(sChange[i]==1){
			if(schk==0){
				sprintf(squery,"%s IDX_%d=%d,Q_%d=%d",
							squery,i,pPerSocketCtx->inven[i],i,pPerSocketCtx->inven_cnt[i]);
			}else{
				sprintf(squery,"%s ,IDX_%d=%d,Q_%d=%d",
							squery,i,pPerSocketCtx->inven[i],i,pPerSocketCtx->inven_cnt[i]);//R}ǉ
			}
			schk=1;
		}
		if(tChange[i]==1){
			if(tchk==0){
				sprintf(tquery,"%s IDX_%d=%d,Q_%d=%d",
							tquery,i,tpPerSocketCtx->inven[i],i,tpPerSocketCtx->inven_cnt[i]);
			}else{
				sprintf(tquery,"%s IDX_%d=%d,Q_%d=%d",
							tquery,i,tpPerSocketCtx->inven[i],i,tpPerSocketCtx->inven_cnt[i]);//R}ǉ
			}
			tchk=1;
		}
	}

	sprintf(squery,"%s where USERID='%s' and NAME='%s'",squery,pPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(squery);
#else
	state = mysql_query(mydata, squery);
#endif

	if( state == -1 ) {
		printf("db_item_trade 1sERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	sprintf(tquery,"%s where USERID='%s' and NAME='%s'",tquery,pPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(tquery);
#else
	state = mysql_query(mydata, tquery);
#endif

	if( state == -1 ) {
		printf("db_item_trade 1tERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	memset(squery,0,1024);
	memset(tquery,0,1024);
	sprintf(squery,"update characters set coin=%d where USERID='%s' and NAME='%s'",
				pPerSocketCtx->coin,pPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(squery);
#else
	state = mysql_query(mydata, squery);
#endif

	if( state == -1 ) {
		printf("db_item_trade 2sERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	sprintf(tquery,"update characters set coin=%d where USERID='%s' and NAME='%s'",
				tpPerSocketCtx->coin,tpPerSocketCtx->userid,pPerSocketCtx->char_name);
#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(tquery);
#else
	state = mysql_query(mydata, tquery);
#endif

	if( state == -1 ) {
		printf("db_item_trade 2tERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	return 1;
}



BOOL Databases::ItemWear(Ptype_session pPerSocketCtx, WORD invidx,BYTE eqidx)
{
	int	state;
	char query[1024];

	memset(query,0,1024);
 	 sprintf(query,"update useritem set IDX_%d=%d,Q_%d=%d where USERID='%s' and NAME='%s'",
 				invidx,pPerSocketCtx->inven[invidx],invidx,pPerSocketCtx->inven_cnt[invidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_sell 1ERROR: %s\n",mysql_error(mydata));
		return 0;
	}

	memset(query,0,1024);
	switch(eqidx){
		case 0:
			sprintf(query,"update characters set I_HEAD=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->eq[eqidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
		break;
		case 1:
			sprintf(query,"update characters set I_L_HAND=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->eq[eqidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
		break;
		case 2:
			sprintf(query,"update characters set I_R_HAND=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->eq[eqidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
		break;
		case 3:
			sprintf(query,"update characters set I_BODY=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->eq[eqidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
		break;
		case 4:
			sprintf(query,"update characters set I_LEG=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->eq[eqidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
		break;
		case 5:
			sprintf(query,"update characters set I_NECKLACE=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->eq[eqidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
		break;
		case 6:
			sprintf(query,"update characters set I_RING=%d where USERID='%s' and NAME='%s'",
						pPerSocketCtx->eq[eqidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);
		break;
		default: return 0;
	}

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_wear ERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	return 1;
}



BOOL Databases::ItemPos(Ptype_session pPerSocketCtx,BYTE sidx,BYTE didx)
{
	int	state;
	char query[1024];

	memset(query,0,1024);
	sprintf(query,"update useritem set IDX_%d=%d,Q_%d=%d,IDX_%d=%d,Q_%d=%d where USERID='%s' and NAME='%s'",
				sidx,pPerSocketCtx->inven[sidx],sidx,pPerSocketCtx->inven_cnt[sidx],didx,pPerSocketCtx->inven[didx],didx,pPerSocketCtx->inven_cnt[didx],
				pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_pos ERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	return 1;
}


BOOL Databases::ItemWarePos(Ptype_session pPerSocketCtx, WORD invidx,BYTE wareidx)
{//q
	int	state;
	char query[1024];

	memset(query,0,1024);
	 sprintf(query,"update useritem set IDX_%d=%d,Q_%d=%d where USERID='%s' and NAME='%s'",
				invidx,pPerSocketCtx->inven[invidx],invidx,pPerSocketCtx->inven_cnt[invidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_pos ERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	memset(query,0,1024);
	 sprintf(query,"update warehouse set IDX_%d=%d,Q_%d=%d where USERID='%s'",
				wareidx,pPerSocketCtx->ware[wareidx],wareidx,pPerSocketCtx->ware_cnt[wareidx],pPerSocketCtx->userid);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_warepos ERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	return 1;
}

BOOL Databases::SaveExpMoney(Ptype_session pPerSocketCtx)
{//q
	int	state;
	char query[1024];

	memset(query,0,1024);
	 sprintf(query,"update characters set EXP=%d,COIN=%d where USERID='%s' and NAME='%s'",
				pPerSocketCtx->exp,pPerSocketCtx->coin,pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_item_pos ERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	return 1;
}


BOOL Databases::SetSkill(Ptype_session pPerSocketCtx, BYTE skidx)
{//q
	int	state;
	char query[1024];

	memset(query,0,1024);
	 sprintf(query,"update skill set IDX%d=%d,LV%d=%d where USERID='%s' and HERO_NAME='%s'",
				skidx,pPerSocketCtx->skill[skidx],skidx,pPerSocketCtx->skill_lv[skidx],pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif

	if( state == -1 ) {
		printf("db_add_skill ERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	return 1;
}


BOOL Databases::LevelUp(Ptype_session pPerSocketCtx)
{//q
	int	state;
	char query[1024];

	memset(query,0,1024);
	 sprintf(query,"update characters set LV=%d,PT=%d where USERID='%s' and HERO_NAME='%s'",
				pPerSocketCtx->level,pPerSocketCtx->lvpoint,pPerSocketCtx->userid,pPerSocketCtx->char_name);

#ifdef _DB_QUERY_ENQUEUE
	state = EnqueQry(query);
#else
	state = mysql_query(mydata, query);
#endif
	if( state == -1 ) {
		printf("db_add_skill ERROR: %s\n",mysql_error(mydata));
		return 0;
	}
	return 1;
}


/*
1. eCxgɂf[^ۑ
2. ԃJE^ɂf[^ۑ
3. ۑXbhʓr..(zL[gp)
*/


//## eCxgɂf[^ۑ
/*
 1.	E					- ok
 2.	̂Ă				- ok
 3.						- ok
 4.						- ok
 5.						- ok
 6.					- ok
 7.	ʒuύX				- ok
 8.	qɕۑ			- ok
 9.	qɈʒuύX		- ok
10.	olKA		- ok
11.	XLK/폜		- ok
12.	xAbv				- ok
13
*/
