#include "network.h"
#include <assert.h>

cNetwork::cNetwork(void)
{
	m_listenSocket=NULL;
	InitSessArray();
	InitializeCriticalSection(&m_cs);
	InitializeCriticalSection(&q_cs);
	m_CurrentUserNo=0;
}

cNetwork::~cNetwork(void)
{
	if(m_listenSocket!=NULL)
	{
		closesocket(m_listenSocket);
		m_listenSocket=NULL;
	}

	WSACleanup();

	DeleteCriticalSection(&m_cs);
	DeleteCriticalSection(&q_cs);
}

void cNetwork::InitSessArray(){
	int i;

	for(i=0;i<MAX_USER;i++) SessArray[i].Flag=0;
	for(i=0;i<MAX_USER;i++){
		SndQueueArray[i].Flag=0;
		SndQueueArray[i].queIndex=i;
	}
}

//ZbVzɃ[U
type_session * cNetwork::AllocSessArray(SOCKET clientSocket){
	int i;
	for(i=0;i<MAX_USER;i++){
		//printf("AllocSessArray ݂%d\n",i);
		if(SessArray[i].Flag==0){
			SessArray[i].Flag=1;
			SessArray[i].sessIndex=i;
			SessArray[i].s.sessIndex=i;
			SessArray[i].s.socket=clientSocket;
			SessArray[i].s.state=conn_state_empty;
			//printf("AllocSessArray  index:%d idx:%d\n",index,i);
			m_CurrentUserNo+=1;
			return &SessArray[i].s;
		}
	}
	return NULL;
}

//ZbVzɃ[U
void cNetwork::FreeSessArray(DWORD index){//ȒPɂƂŏڂ
	
	if(SessArray[index].Flag==1){		
		printf("Free sess index:%d\n",index);
		SessArray[index].Flag=0;
		m_CurrentUserNo-=1;
		return;
	}
}

Ptype_session cNetwork::ret_session_first2(DWORD max){

	int i;

	if(max==0) return NULL;

	for(i=0;i<MAX_USER;i++){
		if(SessArray[i].Flag==1){
			m_ArrayIdx2=i;
			m_ArrayCnt2=1;
			return &SessArray[i].s;
		}
	}
	return NULL;
}

Ptype_session cNetwork::ret_session_next2(DWORD max){

	int i;

	if(max<=m_ArrayCnt2) return NULL;
	for(i=m_ArrayIdx2+1;i<MAX_USER;i++){
		if(SessArray[i].Flag==1){
			m_ArrayIdx2=i;
			m_ArrayCnt2+=1;
			return &SessArray[i].s;
		}
	}
	return NULL;
}

void cNetwork::AllocQueArray(PPerSocketQue ques){
	int i;
	EnterCriticalSection(&q_cs);
	for(i=0;i<MAX_USER;i++){
		//printf("AllocSessArray ݂%d\n",i);
		if(SndQueueArray[i].Flag==0){
			SndQueueArray[i].Flag=1;
			SndQueueArray[i].pPerSocketCtx=ques;
			SndQueueArray[i].pPerSocketCtx->sendContext->queIndex=i;
			printf("AllocQueArray  idx:%d\n",i);
			LeaveCriticalSection(&q_cs);
			return;
		}
	}
	LeaveCriticalSection(&q_cs);
}

//ZbVzɃ[U 
void cNetwork::FreeQueArray(DWORD index){// ȒPɂƂŏڂ 
	
	EnterCriticalSection(&q_cs);
	if(SndQueueArray[index].Flag==1){		
		printf("Free sess index:%d\n",index);
		SndQueueArray[index].Flag=0;
		SndQueueArray[index].pPerSocketCtx=NULL;
		LeaveCriticalSection(&q_cs);
		return;
	}
	LeaveCriticalSection(&q_cs);
}



// NCAg\PbgReNXg\Pbg߂
void cNetwork::CloseClient(Ptype_session c)
{
	EnterCriticalSection(&m_cs);
	if(c!=NULL && c->socket!=INVALID_SOCKET)
	{
		this->m_database.m_Map.CharMapRemove(c);
		FreeSessArray(c->sessIndex);
		closesocket(c->socket);
		c->socket=INVALID_SOCKET;
		c=NULL;
	}
	LeaveCriticalSection(&m_cs);
}

// Per Io Context 
PPerIo cNetwork::AllocForSend(void)
{
	PPerIo pPerIo=NULL;
	void *m_pMemBlock;
    m_pMemBlock=VirtualAlloc(NULL,sizeof(PerIo),MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	pPerIo=reinterpret_cast<PPerIo>(m_pMemBlock);
	return pPerIo;
}

// Per Socket Context ǑM
void cNetwork::AllocPerSocketSndQue(SOCKET clientSocket, char * data, 
											 DWORD dwBytesTransferred, DWORD sessIndex)
{
//ƂőMpL[著M̂ݕʓrł悤ɂȂ΂ȂȂ
	PPerSocketQue SndQue=NULL;
	void *m_pMemBlock;
    
    m_pMemBlock=VirtualAlloc(NULL,sizeof(PPerSocketQue),MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	SndQue=reinterpret_cast<PPerSocketQue>(m_pMemBlock);
	
	SndQue->socket=clientSocket;
	SndQue->sendContext=AllocForSend();//f[^o[
	SndQue->sendContext->flag=1;//FOR TEST
	SndQue->sessIndex=sessIndex;
	AllocQueArray(SndQue);//L[

	ZeroMemory(SndQue->sendContext->Buffer,sizeof(char)*MAX_BUFFER);
	CopyMemory(SndQue->sendContext->Buffer,data,dwBytesTransferred);
	SndQue->sendContext->len=dwBytesTransferred;
    SendPacket(SndQue);


}


void cNetwork::AllocPerSocketSndQue(Ptype_session c,char * data, DWORD dwBytesTransferred)
{
	PPerSocketQue SndQue=NULL;
	void *m_pMemBlock;
    
    m_pMemBlock=VirtualAlloc(NULL,sizeof(PPerSocketQue),MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	SndQue=reinterpret_cast<PPerSocketQue>(m_pMemBlock);

	SndQue->socket=c->socket;
	SndQue->sendContext=AllocForSend();//f[^o[
	SndQue->sendContext->flag=1;//FOR TEST
	SndQue->sessIndex=c->sessIndex;
	AllocQueArray(SndQue);//L[

	ZeroMemory(SndQue->sendContext->Buffer,sizeof(char)*MAX_BUFFER);
printf("AllocPerSocketSndQue Len:%d\n",dwBytesTransferred);
	CopyMemory(SndQue->sendContext->Buffer,data,dwBytesTransferred);
	SndQue->sendContext->len=dwBytesTransferred;
    SendPacket(SndQue);

}


void cNetwork::AllocPerSocketSndQueSectorAll(WORD Ax,WORD Az,char * data, 
												DWORD dwBytesTransferred, Ptype_session c)
{
	PPerSocketQue SndQue=NULL;
	Ptype_session tc;
	void *m_pMemBlock;
	int i,j,x,y;
	type_objlist const * const * tmp_objlist;
	void * tmp_char;
	void * ntmp_char;
	int tm=0;
	for (i=3;i>0;i--) {
		x = Ax -i+2;
		if(x<0 || x>S_WIDTH-1) continue;

		for(j=3;j>0;j--){
			y = Az -j+2;
			if(y<0||y>S_WIDTH-1) continue;

			for(tmp_char=m_database.m_Map.voidListGetFirst(&tmp_objlist,x,y); tmp_char; tmp_char=ntmp_char)
			{
				tc = (Ptype_session)tmp_char;

				ntmp_char = m_database.m_Map.voidListGetNext(&tmp_objlist);
				
				if(tc==NULL) break;
				if(tc->state==conn_state_destroy||tc->state==conn_state_empty) continue;

				if(c==NULL){
					m_pMemBlock=VirtualAlloc(NULL,sizeof(PPerSocketQue),MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
					SndQue=reinterpret_cast<PPerSocketQue>(m_pMemBlock);
					SndQue->socket=tc->socket;
					SndQue->sendContext=AllocForSend();//f[^o[
					SndQue->sendContext->flag=1;//FOR TEST
					SndQue->sessIndex=tc->sessIndex;
					AllocQueArray(SndQue);//L[

					ZeroMemory(SndQue->sendContext->Buffer,sizeof(char)*MAX_BUFFER);
					CopyMemory(SndQue->sendContext->Buffer,data,dwBytesTransferred);
					SndQue->sendContext->len=dwBytesTransferred;
					SendPacket(SndQue);

				}else{
					if(c!=tc){
						m_pMemBlock=VirtualAlloc(NULL,sizeof(PPerSocketQue),MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
						SndQue=reinterpret_cast<PPerSocketQue>(m_pMemBlock);
						SndQue->socket=tc->socket;
						SndQue->sendContext=AllocForSend();//f[^o[
						SndQue->sendContext->flag=1;//FOR TEST
						SndQue->sessIndex=tc->sessIndex;
						AllocQueArray(SndQue);//L[

						ZeroMemory(SndQue->sendContext->Buffer,sizeof(char)*MAX_BUFFER);
						CopyMemory(SndQue->sendContext->Buffer,data,dwBytesTransferred);
						SndQue->sendContext->len=dwBytesTransferred;
						SendPacket(SndQue);
					}
				}// end if(chr==NULL)
			}
		}//inner for loop
	}//end first for loop
}




void cNetwork::DeAllocForSend(PPerIo pPerIo)
{
	assert(pPerIo);
	BOOL bRet=VirtualFree(pPerIo,0,MEM_RELEASE);
	assert(bRet);
	
}

void cNetwork::DeallocPerSocketQue(PPerIo pPerIo)
{
	int i;
	i=pPerIo->queIndex;
	// IO Context 蓖Ă̏
	DeAllocForSend(pPerIo);
 
	printf("DeallocPerSocketQue :%d\n",i);
	BOOL bRet=VirtualFree(SndQueueArray[i].pPerSocketCtx,0,MEM_RELEASE);
	assert(bRet);
	FreeQueArray(i);


}


// Send v
BOOL cNetwork::SendPacket(PPerSocketQue ques)
{
	DWORD dwSendBytes=0;
	DWORD dwFlags=0;
	int ret;
	ret=send(ques->socket, ques->sendContext->Buffer, ques->sendContext->len, 0);
	//printf("SVR send :%d, ret:%d\n",pPerSocketCtx->socket,ret);
	if(ret==-1){
		DeallocPerSocketQue(ques->sendContext);
		return FALSE;
	}else if(ret<dwSendBytes){
		//ꕔ̂Ŏc著M[eBǉKv
	}
	DeallocPerSocketQue(ques->sendContext);
	return TRUE;
}

// T[o[f
void cNetwork::ServerClose(void)
{
	closesocket(m_listenSocket);
	m_listenSocket=INVALID_SOCKET;
	printf("Server Close!\n");;
}

BOOL cNetwork::BeforeAuth(char * data, Ptype_session c, DWORD dwBytesTransferred){

	BOOL ret;
	DWORD headercd;
	char	name[32],pass[32],mesg[MAX_BUFFER];
	short	res;
	WORD	nEnd = PEND;
	int pLen=2,clen,idx,ulen;
 
	memcpy(&res,&data[0],2);//M packet S
	res-=2;
	headercd = data[pLen];
	
	if(c->state==conn_state_empty){//܂F؂Ȃ[U.. F؂s.
		printf("conn_state_empty MSG RCV\n");		
		switch(headercd){

			case PK_USER_AUTH:

				idx=3;
				ulen=data[idx];//name len
				idx+=1;
				if(res<ulen+idx||ulen>31) return FALSE;//error
				memcpy(&name[0],&data[idx],ulen);
				name[ulen]='\0';
				idx+=ulen;
				clen=data[idx];//pass len
				idx+=1;
				if(res<clen+idx||clen>31) return FALSE;//error
				memcpy(&pass[0],&data[idx],clen);
				pass[clen]='\0';

				EnterCriticalSection(&m_cs);

				ret=m_database.UserAuth(name,pass,clen, c);
				//ret=m_database.UserAuth("mitierra","4321",4, pPerSocketCtx);
				if(ret==FALSE){
					printf("user INIT fail for DB\n");
					LeaveCriticalSection(&m_cs);
					return TRUE;
				}

				printf("[UFؐ :%d %s \n",ret,name);
				m_database.m_Map.LocateUser(c);
				LeaveCriticalSection(&m_cs);

				mesg[pLen]=PK_USER_AUTH;
				pLen+=1;
//				mesg[pLen]=this->m_state.GetConnection();
				pLen+=1;
				mesg[pLen]=c->uLen;
				pLen+=1;
				memcpy(&mesg[pLen],&c->userid[0],c->uLen);
				pLen+=c->uLen;
				memcpy(&mesg[pLen],&c->userNo,2);
				pLen+=2;
				memcpy(&mesg[pLen],&nEnd,2);
				pLen+=2;
				memcpy(&mesg[0],&pLen,2);

				AllocPerSocketSndQue(c->socket,mesg,pLen, c->sessIndex);

				//propa my info
				pLen=2;
				mesg[pLen]=PK_OBJ_ADD;
				pLen+=1;
				mesg[pLen]=0;//obj_type 0:user 1:npc 2:item
				pLen+=1;

				mesg[pLen]=1;//cnt
				pLen+=1;
				memcpy(&mesg[pLen],&c->userNo,2);// cnt̕A[v
				pLen+=2;
				mesg[pLen] = c->nLen;
				pLen+=1;
				memcpy(&mesg[pLen],&c->char_name[0],c->nLen);
				pLen+=c->nLen;
				mesg[pLen]=c->race;
				pLen+=1;
				mesg[pLen]=c->sex;
				pLen+=1;
				mesg[pLen]=c->nation;
				pLen+=1;

				memcpy(&mesg[pLen],&c->str,2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->dex,2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->intel,2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->hp_c,2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->mana_c,2);
				pLen+=2;

				memcpy(&mesg[pLen],&c->exp,4);
				pLen+=4;
				memcpy(&mesg[pLen],&c->level,2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->lvpoint,2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->skexp,4);
				pLen+=4;
				mesg[pLen]=c->jobno;
				pLen+=1;
				mesg[pLen]=c->classno;
				pLen+=1;
				mesg[pLen]=c->classlevel;
				pLen+=1;

				memcpy(&mesg[pLen],&c->eq[0],2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->eq[1],2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->eq[2],2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->eq[3],2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->eq[4],2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->coin,4);
				pLen+=4;

				mesg[pLen]=c->userStat;
				pLen+=1;
				mesg[pLen]=c->Dir;
				pLen+=1;
				memcpy(&mesg[pLen],&c->Ax,2);
				pLen+=2;
				memcpy(&mesg[pLen],&c->Ay,2);
				pLen+=2;

				memcpy(&mesg[pLen],&nEnd,2);
				pLen+=2;
				memcpy(&mesg[0],&pLen,2);

				//printf("Ax:%d Az:%d\n",c->Ax,c->Ay);
				AllocPerSocketSndQueSectorAll(c->Ax,c->Ay,mesg,dwBytesTransferred,NULL);
				//Cxg[񑗐M 
				SendInventoryInfo(c);//tbOPNCAgvƂA邱Ƃł...
				//XL񑗐M
				SendSkillInfo(c);
				//}bvɂIuWFNg񑗐M 
				m_database.m_Map.MapGetSectorInfoAll(c,this);
				//tB[hnpc,monsterM
				m_database.m_Npc.Npc3x3SecterInfo(c,this);
				//tB[hitemM
				m_database.m_Item.Item3x3SecterInfo(c,this);
			break;


/*
			case PK_MAP_MOVE_AUTH://RxVȗ(ɏdvłȂ悤łA悤ȖȂ̂..͂ɂȂāAڂȂĂ݂ĂƎv܂B)
				idx=3;
				ulen=c->recvContext->Buffer[idx];//name len
				idx+=1;
				if(res<ulen+idx||ulen>31) return FALSE;//error
				memcpy(&name[0],&c->recvContext->Buffer[idx],ulen);
				name[ulen]='\0';
				idx+=ulen;
				memcpy(&keycode,&c->recvContext->Buffer[idx],4);
		//		pthread_mutex_lock(&keyLock);
		//		res=session_key_cmp(name,ulen,keycode);
		//		pthread_mutex_unlock(&keyLock);
				if(res>=0){
		//			pthread_mutex_lock(&synclock);
		//			session_set_userid(c,name,ulen);
		//			mapinit(c);
					c->state=conn_state_authed;
		//			pthread_mutex_lock(&synclock);
					mesg[pLen]=PK_MAP_MOVE_AUTH;
					pLen+=1;
					mesg[pLen]=0;//res
					pLen+=1;
					memcpy(&mesg[pLen],&nEnd,2);
					pLen+=2;
					memcpy(&mesg[0],&pLen,2);
//					map_pData_snd(c,mesg,pLen);

					//propa my info
					pLen=2;
					mesg[pLen]=PK_OBJ_ADD;
					pLen+=1;
					mesg[pLen]=0;//obj_type 0:user 1:npc 2:item
					pLen+=1;

					mesg[pLen]=1;//cnt
					pLen+=1;
					memcpy(&mesg[pLen],&c->userNo,2);// cnt̕A[v
					pLen+=2;
					mesg[pLen] = c->nLen;
					pLen+=1;
					memcpy(&mesg[pLen],&c->char_name[0],c->nLen);
					pLen+=c->nLen;
					mesg[pLen]=c->race;
					pLen+=1;
					mesg[pLen]=c->sex;
					pLen+=1;
					mesg[pLen]=c->nation;
					pLen+=1;

					memcpy(&mesg[pLen],&c->str,2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->dex,2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->intel,2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->hp_c,2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->mana_c,2);
					pLen+=2;

					memcpy(&mesg[pLen],&c->exp,4);
					pLen+=4;
					memcpy(&mesg[pLen],&c->level,2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->lvpoint,2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->skexp,4);
					pLen+=4;
					mesg[pLen]=c->jobno;
					pLen+=1;
					mesg[pLen]=c->classno;
					pLen+=1;
					mesg[pLen]=c->classlevel;
					pLen+=1;

					memcpy(&mesg[pLen],&c->eq[0],2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->eq[1],2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->eq[2],2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->eq[3],2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->eq[4],2);
					pLen+=2;
					memcpy(&mesg[pLen],&c->coin,4);
					pLen+=4;

					mesg[pLen]=c->userStat;
					pLen+=1;
					if(c->userStat==S_STAND){//stand
						mesg[pLen]=c->Dir;
						pLen+=1;
						memcpy(&mesg[pLen],&c->Ax,2);
						pLen+=2;
						memcpy(&mesg[pLen],&c->Ay,2);
						pLen+=2;
					}else if(c->userStat==S_MOVE){//move
						mesg[pLen]=c->Dir;
						pLen+=1;
						mesg[pLen]=c->moveLevel;
						pLen+=1;
						memcpy(&mesg[pLen],&c->Cx,2);
						pLen+=2;
						memcpy(&mesg[pLen],&c->Cy,2);
						pLen+=2;
						memcpy(&mesg[pLen],&c->Dx,2);
						pLen+=2;
						memcpy(&mesg[pLen],&c->Dy,2);
						pLen+=2;
					}else if(c->userStat==S_FIGHT){//fight
						mesg[pLen]=c->Dir;
						pLen+=1;
						mesg[pLen]=c->tgtype;//^[Qbg^Cv
						pLen+=1;
						if(c->tgtype==0){//pk
						//	usr=(type_session *)c->target;
						//	memcpy(&mesg[pLen],&usr->userNo,2);
							pLen+=2;
						}else{//mon
						//	npc=(type_npc *)c->target;
						//	memcpy(&mesg[pLen],&npc->npc_id,2);
							pLen+=2;
						}
						memcpy(&mesg[pLen],&c->Ax,2);
						pLen+=2;
						memcpy(&mesg[pLen],&c->Ay,2);
						pLen+=2;
					}else{//trade
						mesg[pLen]=c->Dir;
						pLen+=1;
						memcpy(&mesg[pLen],&c->Ax,2);
						pLen+=2;
						memcpy(&mesg[pLen],&c->Ay,2);
						pLen+=2;
					}
					memcpy(&mesg[pLen],&nEnd,2);
					pLen+=2;
					memcpy(&mesg[0],&pLen,2);
			//		map_usersend_All(c->Ax,c->Ay,mesg,pLen,NULL);

			//		thr_inveninfo(c);
			//		thr_skillinfo(c);

			//		map_get_sectorinfo_All(c);//[UM
			//		npc_3x3_secterinfo(c);//tB[hnpc,monsterM
			//		item_3x3_secterinfo(c);//tB[hitem M
				}else{
					return FALSE;
				}
			break;
*/
			default:
				printf("INVALID PACKET RCV\n");
			break;
		}
	}

	return TRUE;
}


BOOL cNetwork::MainAct(char * data,Ptype_session pPerSocketCtx, DWORD dwBytesTransferred){

	char	mesg[MAX_PACKET_SIZE];
	WORD	nEnd = PEND,headercd,Tx,Ty,idx,cLen,rLen=2;
	short	range;
	BYTE	DIR;
	BOOL	res;

	headercd=data[2];

	switch(headercd){
		case PK_USER_CHAT://`bgpPbg
			cLen=data[3];
			//memcpy(&cLen,&data[3],2);
			//if(cLen>dwBytesTransferred-4) return FALSE;
			mesg[rLen]=PK_USER_CHAT;
			rLen+=1;
			mesg[rLen]=pPerSocketCtx->uLen;
			rLen+=1;
			memcpy(&mesg[rLen],&pPerSocketCtx->userid[0],pPerSocketCtx->uLen);
			rLen+=pPerSocketCtx->uLen;
			memcpy(&mesg[rLen],&cLen,2);
			rLen+=2;
			memcpy(&mesg[rLen],&data[4],cLen);
			rLen+=cLen;
			memcpy(&mesg[rLen],&nEnd,2);
			rLen+=2;
			memcpy(&mesg[0],&rLen,2);
			AllocPerSocketSndQueSectorAll(pPerSocketCtx->Ax,pPerSocketCtx->Ay,mesg,rLen,NULL);
			printf("PK_USER_CHAT:ok\n");
		break;
		case PK_REQ_LOC://ʒuvpPbg
			mesg[rLen]=PK_REQ_LOC;
			rLen+=1;
			mesg[rLen]=pPerSocketCtx->Ax;
			rLen+=1;
			mesg[rLen]=pPerSocketCtx->Ay;
			rLen+=1;
			memcpy(&mesg[rLen],&nEnd,2);
			rLen+=2;
			memcpy(&mesg[0],&rLen,2);
			AllocPerSocketSndQue(pPerSocketCtx,mesg,rLen);
			printf("PK_REQ_LOC:ok\n");
		break;
		case PK_CMD_MV://ړ߃pPbg
			memcpy(&Tx,&data[3],2);
			memcpy(&Ty,&data[5],2);
			DIR=data[7];
			if(Tx>=M_SIZE_X||Ty>=M_SIZE_X||DIR>=8){
				res=0;
			}else{
				if(pPerSocketCtx->Cx==Tx&&pPerSocketCtx->Cy==Ty) res=0;
				else{
					EnterCriticalSection(&m_cs);
					res=MvActionSet(pPerSocketCtx,Tx,Ty,DIR);
					LeaveCriticalSection(&m_cs);
				}
			}
			printf("before:%d,%d after:%d,%d res:%d stat:%d\n",
				pPerSocketCtx->Cx,pPerSocketCtx->Cy,Tx,Ty,res,pPerSocketCtx->userStat);

			mesg[rLen] = PK_OBJ_UPDATE_ACT;//2
			rLen+=1;
			mesg[rLen] = T_USER;//obj_type:0 - user
			rLen+=1;
			mesg[rLen] = 1;//count
			rLen+=1;
			memcpy(&mesg[rLen],&pPerSocketCtx->userNo,2);//8
			rLen+=2;
			mesg[rLen]=S_MOVE;
			rLen+=1;
			mesg[rLen]=pPerSocketCtx->Dir;
			rLen+=1;
			mesg[rLen]=pPerSocketCtx->moveLevel;
			rLen+=1;
			memcpy(&mesg[rLen],&pPerSocketCtx->Cx,2);
			rLen+=2;
			memcpy(&mesg[rLen],&pPerSocketCtx->Cy,2);
			rLen+=2;
			memcpy(&mesg[rLen],&pPerSocketCtx->Dx,2);
			rLen+=2;
			memcpy(&mesg[rLen],&pPerSocketCtx->Dy,2);
			rLen+=2;

			memcpy(&mesg[rLen],&nEnd,2);
			rLen+=2;
			memcpy(&mesg[0],&rLen,2);

			if(res==1){
				AllocPerSocketSndQueSectorAll(pPerSocketCtx->Ax,pPerSocketCtx->Ay,mesg,rLen,NULL);
			}
		break;
		case PK_ATTACK://U߃pPbg
			if(pPerSocketCtx->userStat==S_DIE) return FALSE;

			if(pPerSocketCtx->eq[2]==0) range =1;//Ȃ Ê݃`FbN. ͖ɍU 1
			else range= m_database.m_Item.ItemGetRange(pPerSocketCtx->eq[2]);//킠

			if(data[3]==0){//user
				memcpy(&idx,&data[4],2);
				res = m_database.m_Map.MapReturnChrDist(pPerSocketCtx->Cx, pPerSocketCtx->Cy, idx);
				if(range<res||res==-1) return res;
			}else{
				memcpy(&idx,&data[4],2);
				if(idx>=_MAX_MONSTER_NO) return FALSE;
				res = m_database.m_Npc.NpcReturnDist(pPerSocketCtx->Cx, pPerSocketCtx->Cy, idx);
			}

			if(range>=res&&pPerSocketCtx->attack_F_cnt==-1){//U\
				if(data[3]==0){//user
					res=AttackChr(pPerSocketCtx,idx);
				}else{
					res=m_database.m_Npc.NpcChrAttackNpc(pPerSocketCtx,idx,this);
				}
				return res;
			}else return TRUE;
		break;
		case PK_ITEM_BUY://ACewpPbg
			if(dwBytesTransferred!=8) return FALSE;
			m_database.m_Item.ItemBuy(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_ITEM_SELL://ACe̔pPbg
			res=6+data[3]*2;
			if(dwBytesTransferred!=res||data[3]==0) return FALSE;
			m_database.m_Item.ItemSell(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_ITEM_PICK://ACeKpPbg
			if(dwBytesTransferred!=7) return FALSE;
			m_database.m_Item.ItemPick(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_ITEM_DROP:// ACeppPbg 
			if(dwBytesTransferred!=7) return FALSE;
			m_database.m_Item.ItemDrop(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_ITEM_POS:// ACeʒuύXpPbg 
			if(dwBytesTransferred!=9) return FALSE;
			m_database.m_Item.ItemPos(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_ITEM_WEAR:// ACeppPbg 
			if(dwBytesTransferred!=7) return FALSE;
			m_database.m_Item.ItemWear(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_TRADE_REQ:// ACeg[hvpPbg 
			if(dwBytesTransferred!=8) return FALSE;
			m_database.m_Item.ItemTradeRequest(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_TRADE_REQ_OKACeg[hvmFpPbg 
			if(dwBytesTransferred!=8) return FALSE;
			m_database.m_Item.ItemTradeRequestOk(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_TRADE_LIST:// ACeg[hXgpPbg 
			m_database.m_Item.ItemTradeList(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_TRADE_OK:// ACeg[hmFpPbg 
			if(dwBytesTransferred!=5) return FALSE;
			m_database.m_Item.ItemTradeOk(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_TRADE_CANCEL:// ACeg[hpPbg 
			if(dwBytesTransferred!=5) return FALSE;
			m_database.m_Item.ItemTradeCancel(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_WARE_INFO:// ACeqɃpPbg 
			if(dwBytesTransferred!=5) return FALSE;
			m_database.m_Item.ItemWareInfo(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_WARE_POS:// ACeqɈʒuύXpPbg 
			if(dwBytesTransferred!=8) return FALSE;
			m_database.m_Item.ItemWarePos(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_WARE_DEPOS:// ACeqɃACeۑpPbg 
			if(dwBytesTransferred!=7) return FALSE;
			m_database.m_Item.ItemWareDepos(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_SKILL_GET://XLKpPbg
			m_database.m_Skill.SkillGet(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_SKILL_LVUP:// XLxAbvpPbg 
			m_database.m_Skill.SkillLevelUp(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_SKILL_USE:// XLgppPbg 
			m_database.m_Skill.SkillUse(pPerSocketCtx,this);
			return TRUE;
		break;
		case PK_PT_REQ:// p[eBvpPbg 
			if(dwBytesTransferred!=7) return FALSE;
			memcpy(&idx,&data[3],2);
			PartyRequest(pPerSocketCtx,idx);
			return TRUE;
		break;
		case PK_PT_PERMIT:// p[eBvpPbg 
			if(dwBytesTransferred!=8) return FALSE;
			memcpy(&idx,&data[4],2);
			PartyPermit(pPerSocketCtx,idx,data[3]);
			return TRUE;
		break;
		case PK_PT_LEAVE:// p[eBEޗvpPbg 
			if(dwBytesTransferred!=5||pPerSocketCtx->party.flag!=1) return FALSE;
			PartyDiscon(pPerSocketCtx,0);//E
			return TRUE;
		break;
/*		case PK_PT_BAN://3 remain
			if(dwBytesTransferred!=7||pPerSocketCtx->party.flag!=1) return FALSE;
			thr_party_bann(c,dat);
			return TRUE;
		break;
		case PK_PT_CHAT://2 remain
			if(pPerSocketCtx->party.flag!=1) return FALSE;
			thr_party_chat(c,dat);
			return TRUE;
		break;
		case PK_MAP_MOVE_REQ://1 remain
			thr_map_move_req(c,dat,udpsock);
			return TRUE;
		break;
*/


		default:
			return FALSE;
	}
	return TRUE;
}


void cNetwork::SendInventoryInfo(Ptype_session pPerSocketCtx)
{
	char	msg[128];
	WORD	Len=2;
	DWORD	i,cnt=0;
	WORD	nEnd = PEND;

	assert(pPerSocketCtx);
	
	msg[Len]=PK_INVEN_INFO;
	Len+=2;

	for(i=0;i<4;i++){
		if(pPerSocketCtx->inven[i]>0){
			msg[Len]=i;
			Len+=1;
			memcpy(&msg[Len],&pPerSocketCtx->inven[i],2);
			Len+=2;
			msg[Len]=pPerSocketCtx->ware_cnt[i];
			Len+=1;
			cnt+=1;
		}
	}
	msg[3]=cnt;
	memcpy(&msg[Len],&nEnd,2);
	Len+=2;
	memcpy(&msg[0],&Len,2);
	AllocPerSocketSndQue(pPerSocketCtx,msg,Len);
}


void cNetwork::SendSkillInfo(Ptype_session pPerSocketCtx)
{
	char	msg[128];
	WORD	Len=2;
	DWORD	i,cnt=0;
	WORD	nEnd = PEND;

	assert(pPerSocketCtx);
	
	msg[Len]=PK_SKILL_INFO;
	Len+=2;

	for(i=0;i<4;i++){
		if(pPerSocketCtx->skill[i]>0){
			msg[Len]=i;
			Len+=1;
			memcpy(&msg[Len],&pPerSocketCtx->skill[i],2);
			Len+=2;
			msg[Len]=pPerSocketCtx->skill_lv[i];
			Len+=1;
			cnt+=1;
		}
	}
	msg[3]=cnt;
	memcpy(&msg[Len],&nEnd,2);
	Len+=2;
	memcpy(&msg[0],&Len,2);
	AllocPerSocketSndQue(pPerSocketCtx,msg,Len);
}


BOOL cNetwork::MvActionSet(Ptype_session pPerSocketCtx,WORD Dx, WORD Dy, WORD dirL)
{//@ZbeBO

	assert(pPerSocketCtx);
	pPerSocketCtx->Dir		= dirL;
	pPerSocketCtx->userStat	= 1;
	if((m_database.m_Map.MapIsGo(Dx,Dy))==1) return FALSE;
	pPerSocketCtx->Dx 	= Dx;//dest set
	pPerSocketCtx->Dy 	= Dy;
	return TRUE;
}


BOOL cNetwork::AttackChr(Ptype_session c,WORD Index){

	int	rLen=2;
	short	result=0,wasLVup=0;
	short DaMaGe;
	short exp=0;
	char mesg[32];
	unsigned short	nEnd = PEND;

	if(Index>MAXUSERNUM) return FALSE;
	if(SessArray[Index].Flag==0) return FALSE;//݂Ȃ[U
	if(SessArray[Index].s.userStat==S_DIE)	return FALSE;//񂾃[U
	
	EnterCriticalSection(&m_cs);

	DaMaGe = c->attack-SessArray[Index].s.defence;//_[W{{U
	if(DaMaGe<0) DaMaGe=1;
	SessArray[Index].s.hp_c=SessArray[Index].s.hp_c-DaMaGe;

	if(SessArray[Index].s.hp_c<=0){
		result=1;
		SessArray[Index].s.hp_c=0;
		SessArray[Index].s.userStat = S_DIE;

		exp = SessArray[Index].s.level*5;
		c->userStat = S_STAND;
		c->attack_F_cnt=0;
		c->exp +=exp;
		wasLVup=m_database.LevelUpCheck(c);//check lvup 0:not lvup 1:lvup
	}

	LeaveCriticalSection(&m_cs);

	mesg[rLen] = PK_OBJ_UPDATE_ACT;//2
	rLen+=1;
	mesg[rLen] = T_USER;//obj_type:0 - user
	rLen+=1;
	mesg[rLen] = 1;//count
	rLen+=1;
	memcpy(&mesg[rLen],&c->userNo,2);//8
	rLen+=2;
	mesg[rLen]=S_FIGHT;
	rLen+=1;
	mesg[rLen]=c->Dir;
	rLen+=1;
	mesg[rLen]=T_USER;
	rLen+=1;
	memcpy(&mesg[rLen],&Index,2);//target id no.
	rLen+=2;
	memcpy(&mesg[rLen],&SessArray[Index].s.hp_c,2);//target HP==0 Ȃ玀
	rLen+=2;
	if(SessArray[Index].s.hp_c==0){
		memcpy(&mesg[rLen],&c->exp,4);//target HP==0ȂolM
		rLen+=2;
	}
	memcpy(&mesg[rLen],&nEnd,2);
	rLen+=2;
	memcpy(&mesg[0],&rLen,2);
	AllocPerSocketSndQueSectorAll(c->Ax, c->Ay, mesg, rLen,NULL);
	
//	if(result==1){//npc die item make
//		item drop
//		npc_drop_item(npcArray[Index], c->userNo);
//	}

	if(wasLVup==TRUE){//status recal
		rLen=2;
		mesg[rLen] = PK_LEVELUP;//2
		rLen+=1;
		mesg[rLen] = c->level;//4
		rLen+=1;
		memcpy(&mesg[rLen],&nEnd,2);
		rLen+=2;
		memcpy(&mesg[0],&rLen,2);
		AllocPerSocketSndQue(c,mesg,rLen);
	}
	return TRUE;
}


Ptype_session cNetwork::ReturnSession(WORD idx){

	if(idx>=MAXUSERNUM) return NULL;
	if(SessArray[idx].Flag==0) return NULL;
	return &SessArray[idx].s;
}


void cNetwork::PartyRequest(Ptype_session c,WORD tgidx){

	Ptype_session	tc;
	unsigned short	nEnd = PEND,pLen=2;
	short	lvpt;
	char	msg[128];

	msg[pLen] = PK_PT_REQ;
	pLen+=1;

	if(c->level<4){//4菬΃p[eB[_[ł
		msg[pLen] = 1;//error 1
		pLen += 1;
		memcpy(&msg[pLen], &nEnd, 2);
		pLen += 2;
		memcpy(&msg[0], &pLen, 2);
		AllocPerSocketSndQue(c,msg,pLen);
		return;
	}

	if(c->party.flag==1){
		if(c->party.cnt==3||c->party.ison1!=2){//mem exceed or not master
			msg[pLen] = 2;//error 2
			pLen += 1;
			memcpy(&msg[pLen], &nEnd, 2);
			pLen += 2;
			memcpy(&msg[0], &pLen, 2);
			AllocPerSocketSndQue(c,msg,pLen);
			return;
		}
	}

	tc=ReturnSession(tgidx);//`FbN\..
	if(tc==NULL){
		msg[pLen] = 3;//error 3
		pLen += 1;
		memcpy(&msg[pLen], &nEnd, 2);
		pLen += 2;
		memcpy(&msg[0], &pLen, 2);
		AllocPerSocketSndQue(c,msg,pLen);
		return;
	}
	if(tc->party.flag==1){//łɃp[eB
		msg[pLen] = 4;//error 4
		pLen += 1;
		memcpy(&msg[pLen], &nEnd, 2);
		pLen += 2;
		memcpy(&msg[0], &pLen, 2);
		AllocPerSocketSndQue(c,msg,pLen);
		return;
	}
	if(tc->level>=c->level)
		lvpt = tc->level-c->level;
	else
		lvpt = c->level-tc->level;
	if(lvpt>5){//levelႢŃp[eBs
		msg[pLen] = 5;//error 5
		pLen += 1;
		memcpy(&msg[pLen], &nEnd, 2);
		pLen += 2;
		memcpy(&msg[0], &pLen, 2);
		AllocPerSocketSndQue(c,msg,pLen);
		return;
	}

	msg[pLen] = RET_TRUE;
	pLen += 1;
	memcpy(&msg[pLen],&c->userNo,2);
	pLen += 2;
	memcpy(&msg[pLen], &nEnd, 2);
	pLen += 2;
	memcpy(&msg[0], &pLen, 2);

	EnterCriticalSection(&m_cs);
	c->party.waitfor=tc;
	tc->party.waitfor=c;
	LeaveCriticalSection(&m_cs);
	AllocPerSocketSndQue(tc,msg,pLen);
}


void cNetwork::PartyPermit(Ptype_session c,WORD ptMain, WORD flag){//ptMain: p[eB[_[ flag 0:  1:   2:ق̍ƒ

	Ptype_session 	tc=NULL;//p[eBv
	Ptype_session 	cc=NULL;//p[eB[_[ĂΏێ
	Ptype_session 	mc=NULL;//p[eBo[
	WORD nEnd = PEND,pLen=2;
	short tNo=0,Len;
	int newFlag=0;
	char msg[512],msg2[512];

	msg[pLen] = PK_PT_PERMIT;
	pLen+=1;

	if(c->party.flag==1){//̃pPbg̓p[eBΏێ҂̂.. łɃp[eB..
		msg[pLen] = 3;
		pLen += 1;
		memcpy(&msg[pLen], &c->userNo, 2);
		pLen += 2;
		memcpy(&msg[pLen], &nEnd, 2);
		pLen += 2;
		memcpy(&msg[0], &pLen, 2);
		AllocPerSocketSndQue(c,msg,pLen);
		return;
	}

	tc=(Ptype_session)c->party.waitfor;//p[eB[_[
	if(tc!=NULL){
		cc=(Ptype_session)tc->party.waitfor;//p[eB[_[Ăp[eBΏێ
		if(cc==NULL){
			msg[pLen] = 4;
			pLen += 1;
			memcpy(&msg[pLen], &c->userNo, 2);
			pLen += 2;
			memcpy(&msg[pLen], &nEnd, 2);
			pLen += 2;
			memcpy(&msg[0], &pLen, 2);
			AllocPerSocketSndQue(c,msg,pLen);
			return;
		}

		if(flag!=0){
			msg[pLen] = 1;//
			pLen += 1;
			memcpy(&msg[pLen], &c->userNo, 2);
			pLen += 2;
			memcpy(&msg[pLen], &nEnd, 2);
			pLen += 2;
			memcpy(&msg[0], &pLen, 2);
			AllocPerSocketSndQue(tc,msg,pLen);
			return;
		}

		if(tc->userNo==ptMain&&cc->userNo==c->userNo){//p[eB[_[T
			if(tc->party.flag==1){//łɃp[eB[_[łꍇ
				if(tc->party.ison1!=2){//p[eB[_[ł͂Ȃ
					msg[pLen] = 5;
					pLen += 1;
					memcpy(&msg[pLen], &c->userNo, 2);
					pLen += 2;
					memcpy(&msg[pLen], &nEnd, 2);
					pLen += 2;
					memcpy(&msg[0], &pLen, 2);
					AllocPerSocketSndQue(c,msg,pLen);
					return;
				}
			}

			EnterCriticalSection(&m_cs);
			if(tc->party.flag==0){//ŏ̃p[eB
				newFlag=1;
				tc->party.flag=1;
				tc->party.cnt=2;

				tc->party.memidx=1;	//pt main
				tc->party.master=NULL;
				tc->party.ison1=2;	//ptmain
				tc->party.mem2=c;
				tc->party.ison2=1;

				c->party.flag=1;
				c->party.master=tc;
				c->party.ison1=1;		//ptmain
				c->party.ison2=2;

				tNo=2;//VłCfbNX

			}else{//łɂƂ..
				if(tc->party.cnt==3){
					LeaveCriticalSection(&m_cs);
					msg[pLen] = 6;
					pLen += 1;
					memcpy(&msg[pLen], &c->userNo, 2);
					pLen += 2;
					memcpy(&msg[pLen], &nEnd, 2);
					pLen += 2;
					memcpy(&msg[0], &pLen, 2);
					AllocPerSocketSndQue(c,msg,pLen);
					AllocPerSocketSndQue(tc,msg,pLen);
					return;
				}

				newFlag=0;
				tc->party.cnt=3;
				c->party.flag=1;
				c->party.master=tc;
				c->party.ison1=1;//ptmain

				if(tc->party.ison2==0){//QԖڂ̃R}ĂꍇA 2Ԗڂ̃o[ƂĎQ..
					tNo=2;//VłCfbNX
					mc=(Ptype_session)tc->party.mem3;
					if(mc==NULL) tNo=0;
					else{
						tc->party.mem2=c;
						tc->party.ison2=1;
						c->party.mem2=c;
						c->party.ison2=2;
						c->party.memidx=2;//2
						mc->party.mem3=c;
						mc->party.ison3=1;
					}
				}else if(tc->party.ison3==0){//RԖڂ̃R}Ăꍇ
					tNo=3;//VłCfbNX
					mc=(Ptype_session)tc->party.mem2;
					if(mc==NULL) tNo=0;
					else{
						tc->party.mem3=c;
						tc->party.ison3=1;
						c->party.mem3=c;
						c->party.ison3=2;
						c->party.memidx=3;//2
						mc->party.mem2=c;
						mc->party.ison2=1;
					}
				}
				if(tNo==0){//G[...
					//tcc party break..
					LeaveCriticalSection(&m_cs);//mutex unlock
					msg[pLen] = 7;
					pLen += 1;
					memcpy(&msg[pLen], &c->userNo, 2);
					pLen += 2;
					memcpy(&msg[pLen], &nEnd, 2);
					pLen += 2;
					memcpy(&msg[0], &pLen, 2);
					AllocPerSocketSndQue(c, msg, pLen);
					AllocPerSocketSndQue(tc, msg, pLen);
					return;
				}
			}
			LeaveCriticalSection(&m_cs);

			msg[pLen] = RET_TRUE;
			pLen += 1;
			msg[pLen] = 2;//cnt
			pLen += 1;
			memcpy(&msg[pLen], &c->userNo, 2);
			pLen += 2;
			memcpy(&msg[pLen], &nEnd, 2);
			pLen += 2;
			memcpy(&msg[0], &pLen, 2);

			Len=2;
			msg2[Len] = PK_PT_INFO;
			Len += 1;
			msg2[Len] = 2;//cnt
			Len += 1;
			memcpy(&msg2[Len], &c->userNo, 2);
			Len += 2;
			memcpy(&msg2[Len], &c->hp_c, 2);
			Len += 2;
			memcpy(&msg2[Len], &c->Cx, 2);
			Len += 2;
			memcpy(&msg2[Len], &c->Cy, 2);
			Len += 2;
			memcpy(&msg2[Len], &tc->userNo, 2);
			Len += 2;
			memcpy(&msg2[Len], &tc->hp_m, 2);
			Len += 2;
			memcpy(&msg2[Len], &tc->hp_c, 2);
			Len += 2;
			memcpy(&msg2[Len], &tc->Cx, 2);
			Len += 2;
			memcpy(&msg2[Len], &tc->Cy, 2);
			Len += 2;
			memcpy(&msg2[Len], &nEnd, 2);
			Len += 2;
			memcpy(&msg2[0], &Len, 2);

			if(newFlag==1){
				AllocPerSocketSndQue(tc, msg, pLen);//master M
				AllocPerSocketSndQue(c, msg2, Len);//new member M
			}else{
				AllocPerSocketSndQue(tc, msg, pLen);//master M
				AllocPerSocketSndQue(mc, msg, pLen);//member M
				AllocPerSocketSndQue(c, msg2, Len);//new member M
			}
			return;
		}else{//error
			msg[pLen] = 7;//p[eB[_[̏񂪈Ă..
			pLen += 1;
			memcpy(&msg[pLen], &c->userNo, 2);
			pLen += 2;
			memcpy(&msg[pLen], &nEnd, 2);
			pLen += 2;
			memcpy(&msg[0], &pLen, 2);
			AllocPerSocketSndQue(c, msg, pLen);
			return;
		}
	}else{
		msg[pLen] = 8;//p[eB[_[̏񂪈Ă..
		pLen += 1;
		memcpy(&msg[pLen], &c->userNo, 2);
		pLen += 2;
		memcpy(&msg[pLen], &nEnd, 2);
		pLen += 2;
		memcpy(&msg[0], &pLen, 2);
		AllocPerSocketSndQue(c, msg, pLen);
	}
}


void cNetwork::PartyDiscon(Ptype_session c,WORD flag){//flag 0:E 1:disconnect

	Ptype_session 	tc=NULL;
	Ptype_session 	mc1=NULL;
	Ptype_session 	mc2=NULL;

	WORD nEnd = PEND,pLen=2;
	char msg[128];

	if(c==NULL) return;
	if(c->party.flag==0) return;

	if(c->party.ison1==2){//p[eB[_[̏ꍇ party break
		msg[pLen] = PK_PT_BREAK;
		pLen+=1;
		memcpy(&msg[pLen],&c->userNo,2);
		pLen += 2;
		memcpy(&msg[pLen], &nEnd, 2);
		pLen += 2;
		memcpy(&msg[0], &pLen, 2);

		if(flag==0){//E
			EnterCriticalSection(&m_cs);
			if(c->party.ison2==1){
				mc1=(Ptype_session)c->party.mem2;
				if(mc1!=NULL){
					PartySet(mc1);
				}
			}
			if(c->party.ison3==1){
				mc2=(Ptype_session)c->party.mem3;
				if(mc2!=NULL){
					PartySet(mc2);
				}
			}
			PartySet(c);
			LeaveCriticalSection(&m_cs);

			AllocPerSocketSndQue(c, msg, pLen);

		}else{//disconn
			if(c->party.ison2==1){
				mc1=(Ptype_session)c->party.mem2;
				if(mc1!=NULL){
					PartySet(mc1);
				}
			}
			if(c->party.ison3==1){
				mc2=(Ptype_session)c->party.mem3;
				if(mc2!=NULL){
					PartySet(mc2);
				}
			}
		}
		if(mc1) AllocPerSocketSndQue(mc1, msg, pLen);//p[eB̂m点..
		if(mc2) AllocPerSocketSndQue(mc2, msg, pLen);

	}else{//p[eBo[̏ꍇ

		tc=(Ptype_session)c->party.master;
		if(tc!=NULL){
			if(tc->party.cnt==2){//party break

				msg[pLen] = PK_PT_BREAK;
				pLen+=1;
				memcpy(&msg[pLen],&tc->userNo,2);
				pLen += 2;
				memcpy(&msg[pLen], &nEnd, 2);
				pLen += 2;
				memcpy(&msg[0], &pLen, 2);

				if(flag==0){//E
					EnterCriticalSection(&m_cs);
					if(tc->party.ison2==1){
						mc1=(Ptype_session)tc->party.mem2;
						if(mc1!=NULL){
							PartySet(mc1);
						}
					}
					if(tc->party.ison3==1){
						mc2=(Ptype_session)tc->party.mem3;
						if(mc2!=NULL){
							PartySet(mc2);
						}
					}
					PartySet(tc);
					LeaveCriticalSection(&m_cs);
				}else{//disconn
					EnterCriticalSection(&m_cs);
					if(tc->party.ison2==1){
						mc1=(Ptype_session)tc->party.mem2;
						if(mc1!=NULL){
							PartySet(mc1);
						}
					}
					if(tc->party.ison3==1){
						mc2=(Ptype_session)tc->party.mem3;
						if(mc2!=NULL){
							PartySet(mc2);
						}
					}
					PartySet(tc);
					LeaveCriticalSection(&m_cs);
				}
				AllocPerSocketSndQue(tc, msg, pLen);
				if(mc1) AllocPerSocketSndQue(mc1, msg, pLen);//p[eB̉̂m点..
				if(mc2) AllocPerSocketSndQue(mc2, msg, pLen);
			}else{//p[eBo[̂ݒE...
				msg[pLen] = PK_PT_LEAVE;
				pLen+=1;
				msg[pLen] = 0;
				pLen+=1;
				memcpy(&msg[pLen],&c->userNo,2);
				pLen += 2;
				memcpy(&msg[pLen], &nEnd, 2);
				pLen += 2;
				memcpy(&msg[0], &pLen, 2);

				tc=(Ptype_session)c->party.master;
				if(tc==NULL) return;

				if(flag==0){//E
					EnterCriticalSection(&m_cs);
					if(tc->party.ison2==1){
						mc1=(Ptype_session)tc->party.mem2;
						if(mc1==c){
							PartySet(mc1);
							tc->party.ison1=0;
							tc->party.cnt=2;
							tc->party.mem2=NULL;
							tc->party.ison2=0;
						}else{//error
							PartySet(c);
							LeaveCriticalSection(&m_cs);
							return;
						}
					}else{
						mc2=(Ptype_session)tc->party.mem3;
						if(mc2==c){
							PartySet(mc2);
							tc->party.ison1=0;
							tc->party.cnt=2;
							tc->party.mem2=NULL;
							tc->party.ison2=0;
						}else{
							PartySet(c);
							LeaveCriticalSection(&m_cs);
							return;
						}
					}
					LeaveCriticalSection(&m_cs);
					if(mc1) AllocPerSocketSndQue(mc1, msg, pLen);//p[eB̂m点..
					if(mc2) AllocPerSocketSndQue(mc2, msg, pLen);
					AllocPerSocketSndQue(tc, msg, pLen);
				}else{//disconn
					EnterCriticalSection(&m_cs);
					if(tc->party.ison2==1){
						mc1=(Ptype_session)tc->party.mem2;
						if(mc1==c){
							PartySet(mc1);
							tc->party.ison1=0;
							tc->party.cnt=2;
							tc->party.mem2=NULL;
							tc->party.ison2=0;
						}else{//error
							PartySet(c);
							LeaveCriticalSection(&m_cs);
							return;
						}
					}else{
						mc2=(Ptype_session)tc->party.mem3;
						if(mc2==c){
							PartySet(mc2);
							tc->party.ison1=0;
							tc->party.cnt=2;
							tc->party.mem2=NULL;
							tc->party.ison2=0;
						}else{
							PartySet(c);
							LeaveCriticalSection(&m_cs);
							return;
						}
					}
					LeaveCriticalSection(&m_cs);
				}
				if(mc1&&mc1!=c) AllocPerSocketSndQue(mc1, msg, pLen);//bk pt break..
				if(mc2&&mc2!=c) AllocPerSocketSndQue(mc2, msg, pLen);
				AllocPerSocketSndQue(tc, msg, pLen);
			}
		}//tc==NULL
	}//pt member
}


void cNetwork::PartySet(Ptype_session c){
	c->party.flag=0;
	c->party.ison1=0;
	c->party.cnt=0;
	c->party.memidx=0;
	c->party.infoFcnt=0;
	c->party.waitfor=NULL;
	c->party.master=NULL;
	c->party.ison1=0;
	c->party.mem2=NULL;
	c->party.ison2=0;
	c->party.mem3=NULL;
	c->party.ison3=0;
}


