#include "npc.h"
#include "network.h"
#include <assert.h>
#include <math.h>
#include <time.h>

void Npcs::InitNpc(void){

	for(int i=0;i<_MAX_MONSTER_NO;i++){
		npcArray[i]=NULL;
	}	
}


void * Npcs::voidNpcListGetFirst(type_objlist const * const * * save,unsigned short i, unsigned short j)
{
    void * conn;

    if (!save)
	return NULL;

    *save = (type_objlist const * const *)&(mapNpcArray[i][j].objL); /* avoid warning */

    if (!**save)
    {
	*save = NULL;
	return NULL;
    }
    conn = m_obj.get_node_objlist(**save);
    *save = m_obj.get_next_node_objlist_const(**save);

    return conn;
}


void * Npcs::voidNpcListGetNext(type_objlist const * const * * save)
{
    void * conn;

    if (!save)
	return NULL;

    if (!*save || !**save)
    {
	*save = NULL;
	return NULL;
    }
    conn = m_obj.get_node_objlist(**save);
    *save = m_obj.get_next_node_objlist_const(**save);

    return conn;
}


void Npcs::NpcSetDef(char div, short no, char gtype, char level, char speed, short * item, char * rate){

	if(div==0){//npc
		def_npc[no].no=no;
		def_npc[no].gtype=gtype;
		def_npc[no].level=level;
		def_npc[no].speed=speed;
		memcpy(&def_npc[no].item,&item,24);//short 2  2*12
		memcpy(&def_npc[no].rate,&rate,12);
	}else{//monster
		def_mon[no].no=no;
		def_mon[no].gtype=gtype;
		def_mon[no].level=level;
		def_mon[no].speed=speed;
		memcpy(&def_mon[no].item,&item,24);//short 2  2*12
		memcpy(&def_mon[no].rate,&rate,12);
	}
}

void Npcs::NpcDataSet(char div,short no,short x,short y){//char gtype, char level, char speed,

	void *m_pMemBlock;
	char level=0;
	
    const int AllocationSize=sizeof(type_npc); // ̑傫
    m_pMemBlock=VirtualAlloc(NULL,AllocationSize,MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	assert(m_pMemBlock);

	type_npc * temp=reinterpret_cast<type_npc*>(m_pMemBlock);

	temp->div		=	div;

	if(div==1){
		no=no-100;
		temp->npc_id=npc;
		npc+=1;
		temp->speed	= def_npc[no].speed;
		temp->gtype	= def_npc[no].gtype;
	}else{
		no=no-10;
		temp->npc_id=mon;
		mon+=1;
		temp->speed	= def_mon[no].speed;
		temp->gtype	= def_mon[no].gtype;
	}
	temp->x 					= x;
	temp->y						= y;
	temp->dx					= x;
	temp->dy					= y;
	temp->DirLoc				= 0;
	temp->ARx					= x/S_UNITSIZE;
	temp->ARy					= y/S_UNITSIZE;
	temp->BSx					= temp->ARx;
	temp->BSy					= temp->ARy;
	temp->Gx					= x;
	temp->Gy					= y;
	temp->level					= level;

	temp->sk_stat				= S_STAND;
	temp->mvstatus				= 0;
	temp->targetChr				= NULL;
	temp->tgFlag				= 0;
	temp->recov_F_cnt			= 0;
	temp->move_F_cnt			= 0;
	temp->heat_F_cnt			= 0;
	temp->active_F_cnt			= 0;
	temp->rotate_F_cnt			= 0;
	temp->ret_F_cnt				= 0;
	temp->wait_F_cnt			= 0;
	temp->regen_F_cnt			= 0;

	switch(temp->gtype){
		case 0:
		temp->tHP				= level * 50;
		temp->HP				= temp->tHP;
		temp->AP				= level + 10;
		temp->DP				= level + 10;
		temp->EXP				= level * 10;
		temp->Sight				= 5;
		temp->tgLen				= 1;
		temp->bat_type			= 0;
		break;
		case 1:
		temp->tHP				= level * 60;
		temp->HP				= temp->tHP;
		temp->AP				= level + 12;
		temp->DP				= level + 12;
		temp->EXP				= level * 12;
		temp->Sight				= 6;
		temp->tgLen				= 2;
		temp->bat_type			= 0;
		break;
		case 2:
		temp->tHP				= level * 70;
		temp->HP				= temp->tHP;
		temp->AP				= level + 14;
		temp->DP				= level + 14;
		temp->EXP				= level * 14;
		temp->Sight				= 7;
		temp->tgLen				= 2;
		temp->bat_type			= 0;
		break;
		case 3:
		temp->tHP				= level * 70;
		temp->HP				= temp->tHP;
		temp->AP				= level + 16;
		temp->DP				= level + 16;
		temp->EXP				= level * 16;
		temp->Sight				= 8;
		temp->tgLen				= 3;
		temp->bat_type			= 0;
		break;
	}

	npcArray[npc_cnt] =temp;
	NpcMapInit(npcArray[npc_cnt]);//ʒuZbeBO
	npc_cnt+=1;
printf("npc ǉ ݂̃JEg:%d type:%d speed:%d,no:%d %d,%d sec:%d,%d\n",npc_cnt,temp->div,temp->speed,no,temp->x,temp->y,temp->ARx,temp->ARy);
}

void Npcs::NpcMapInit(type_npc * npc){//npcʒuZbeBO
	npc->ARx = npc->x/S_UNITSIZE;
	npc->ARy = npc->y/S_UNITSIZE;
	m_obj.add_node_objlist(&(mapNpcArray[npc->ARx][npc->ARy].objL),npc);//direct map address access
}


void Npcs::Npc3x3SecterInfo(Ptype_session pPerSocketCtx,PVOID param){

	int i,j,x,y;
	type_objlist  const * const * tmp_objlist;
	void * ntmp_npc,* npc;	//
	type_npc * tmp_npc;
	WORD objCnt=0,nEnd = PEND;
	short Len=2,tmp;
	char retdata[MAX_PACKET_SIZE];
	
	cNetwork* pNc=(cNetwork*)param;

	retdata[Len] = PK_OBJ_ADD;				//2
	Len+=1;
	retdata[Len] = T_NPC;//obj_type : NPC	//3
	Len+=1;
	//retdata[Len] = objCnt;				//4
	Len+=1;
	tmp = 1024-40;
	for (i=3;i>0;i--) {
		x = pPerSocketCtx->Ax -i+2;
		if(x<0 || x>S_WIDTH-1) continue;

		for(j=3;j>0;j--){
			y = pPerSocketCtx->Ay -j+2;
			if(y<0||y>S_WIDTH-1) continue;

			for(npc=voidNpcListGetFirst(&tmp_objlist,x,y); npc; npc=ntmp_npc)
			{
				tmp_npc = (type_npc *)npc;
				ntmp_npc = voidNpcListGetNext(&tmp_objlist);
				if(tmp_npc->status==S_DIE) continue;
				objCnt+=1;
				retdata[Len] = tmp_npc->div;//X^[ npc
				Len+=1;
				retdata[Len] = tmp_npc->gtype;//ރ^Cv
				Len+=1;
				memcpy(&retdata[Len],&tmp_npc->npc_id,2);
				Len+=2;
				memcpy(&retdata[Len],&tmp_npc->level,2);
				Len+=2;
				memcpy(&retdata[Len],&tmp_npc->tHP,2);
				Len+=2;
				memcpy(&retdata[Len],&tmp_npc->HP,2);
				Len+=2;
				memcpy(&retdata[Len],&tmp_npc->AP,2);
				Len+=2;
				retdata[Len] = tmp_npc->status;
				Len+=1;
				retdata[Len] = tmp_npc->DirLoc;
				Len+=1;

				if(tmp_npc->status==S_STAND){//stand
					memcpy(&retdata[Len],&tmp_npc->x,2);
					Len+=2;
					memcpy(&retdata[Len],&tmp_npc->y,2);
					Len+=2;
				}else if(tmp_npc->status==S_MOVE){//move
					retdata[Len] = tmp_npc->DirLoc;
					Len+=1;
					retdata[Len] = tmp_npc->speed;
					Len+=1;
					memcpy(&retdata[Len],&tmp_npc->x,2);
					Len+=2;
					memcpy(&retdata[Len],&tmp_npc->y,2);
					Len+=2;
					memcpy(&retdata[Len],&tmp_npc->dx,2);
					Len+=2;
					memcpy(&retdata[Len],&tmp_npc->dy,2);
					Len+=2;
				}else if(tmp_npc->status==S_FIGHT){//fight
					memcpy(&retdata[Len],&tmp_npc->x,2);
					Len+=2;
					memcpy(&retdata[Len],&tmp_npc->y,2);
					Len+=2;
					memcpy(&retdata[Len],&tmp_npc->targetNO,2);
					Len+=2;
				}

				if(Len>tmp){
					memcpy(&retdata[Len],&nEnd,2);
					Len+=2;
					retdata[4] = objCnt;
					Len+=1;
					memcpy(&retdata[0],&Len,2);
					pNc->AllocPerSocketSndQue(pPerSocketCtx,retdata,Len);
					Len=5;
					objCnt=0;
				}
			}
		}
	}
	if(objCnt>0){
		memcpy(&retdata[Len],&nEnd,2);
		Len+=2;
		retdata[4] = objCnt;
		Len+=1;
		memcpy(&retdata[0],&Len,2);
		pNc->AllocPerSocketSndQue(pPerSocketCtx,retdata,Len);
	}
}


int Npcs::NpcReturnDist(WORD x, WORD y, WORD idx)
{//x,y {W, idx=X^[index

	int tmp,dx,dy;

	if(idx >=_MAX_MONSTER_NO) return -1;
	dx = npcArray[idx]->x - x;
	dy = npcArray[idx]->y - y;
	tmp = dx*dx + dy*dy;
	if(tmp==0) return 0;
	tmp = sqrt(tmp);
	return tmp;//WƃLN^[Ԃ̋..
}


BOOL Npcs::NpcChrAttackNpc(Ptype_session c,WORD Index,PVOID param)
{
	DWORD	rLen=2,exp=0,coin=0;
	short	result=0,wasLVup=0,DaMaGe;
	Ptype_session mc,pc;
	char	mesg[32];
	WORD	nEnd = PEND;
	int		pt0,pt1,pt2;

	if(Index>_MAX_MONSTER_NO) return FALSE;
	if(npcArray[Index]->div==1) return FALSE;
	if(npcArray[Index]->status==S_DIE) return FALSE;//łɎ񂾃X^[
	
	cNetwork* pNc=(cNetwork*)param;

	EnterCriticalSection(&n_cs);

	npcArray[Index]->targetNO = c->userNo;
	npcArray[Index]->targetChr = c;
	npcArray[Index]->mvstatus=0;
	npcArray[Index]->status = S_FIGHT;

	DaMaGe = c->attack-npcArray[Index]->DP;//_[W{{U
	if(DaMaGe<0) DaMaGe=1;

	npcArray[Index]->HP=npcArray[Index]->HP-DaMaGe;

	if(npcArray[Index]->HP<=0){
		result=1;//monster die
		npcArray[Index]->HP=0;
		npcArray[Index]->targetNO = 0;
		npcArray[Index]->targetChr = NULL;
		npcArray[Index]->status = S_DIE;

		exp = npcArray[Index]->EXP;
		coin += npcArray[Index]->level*10;
		LeaveCriticalSection(&n_cs);
	}else{
		LeaveCriticalSection(&n_cs);

		EnterCriticalSection(&pNc->m_cs);
		c->userStat = S_FIGHT;//Վl
		c->tgtype = 1;//npc/usr
		c->target = npcArray[Index];
		c->target_id = Index;
		c->attack_F_cnt=0;
		LeaveCriticalSection(&pNc->m_cs);
	}

	mesg[rLen] = PK_OBJ_UPDATE_ACT;//2
	rLen+=1;
	mesg[rLen] = T_USER;//obj_type:0 - user
	rLen+=1;
	mesg[rLen] = 1;//count
	rLen+=1;
	memcpy(&mesg[rLen],&c->userNo,2);//8
	rLen+=2;
	mesg[rLen]=S_FIGHT;
	rLen+=1;
	mesg[rLen]=c->Dir;
	rLen+=1;
	mesg[rLen]=T_NPC;
	rLen+=1;
	memcpy(&mesg[rLen],&Index,2);//target id no.
	rLen+=2;
	memcpy(&mesg[rLen],&npcArray[Index]->HP,2);//target HP==0 Ȃ玀
	rLen+=2;
	if(npcArray[Index]->HP==0){
		memcpy(&mesg[rLen],&c->exp,4);//target HP==0ȂolM
		rLen+=2;
	}
	memcpy(&mesg[rLen],&nEnd,2);
	rLen+=2;
	memcpy(&mesg[0],&rLen,2);
	pNc->AllocPerSocketSndQueSectorAll(c->Ax, c->Ay, mesg, rLen,NULL);

	if(result==1){//npc die item make
		//item drop
		NpcDropItem(npcArray[Index], c->userNo,param);
		
		if(c->party.flag==1){//p[eB[olVFA..
			if(c->party.ison1==2){//p[eB̂Ƃ
				coin = coin/c->party.cnt;
				exp = exp/c->party.cnt;
				mc=c;
			}else{
				mc=(Ptype_session)c->party.master;
				if(mc==NULL) return FALSE;
				coin = coin/mc->party.cnt;
				exp = exp/mc->party.cnt;
			}
			EnterCriticalSection(&pNc->m_cs);
			mc->coin+= coin;
			mc->exp +=exp;
			pt0=pNc->m_database.LevelUpCheck(mc);

			if(mc->party.ison2==1){
				pc=(Ptype_session)mc->party.mem2;
				if(pc==NULL){
					LeaveCriticalSection(&pNc->m_cs);
					return FALSE;
				}
				pc->coin+= coin;
				pc->exp +=exp;
				pt1=pNc->m_database.LevelUpCheck(pc);
			}
			if(mc->party.ison3==1){
				pc=(Ptype_session)mc->party.mem3;
				if(pc==NULL){
					LeaveCriticalSection(&pNc->m_cs);
					return FALSE;
				}
				pc->coin+= coin;
				pc->exp +=exp;
				pt2=pNc->m_database.LevelUpCheck(pc);//levelup check
			}
			LeaveCriticalSection(&pNc->m_cs);

			if(pt0==1){
				rLen=2;
				mesg[rLen] = PK_LEVELUP;//2
				rLen+=1;
				mesg[rLen] = mc->level;//4
				rLen+=1;
				memcpy(&mesg[rLen],&nEnd,2);
				rLen+=2;
				memcpy(&mesg[0],&rLen,2);
				pNc->AllocPerSocketSndQue(mc,mesg,rLen);
			}
			if(pt1==1){
				pc=(Ptype_session)mc->party.mem2;
				if(pc==NULL) return 0;
				rLen=2;
				mesg[rLen] = PK_LEVELUP;//2
				rLen+=1;
				mesg[rLen] = pc->level;//4
				rLen+=1;
				memcpy(&mesg[rLen],&nEnd,2);
				rLen+=2;
				memcpy(&mesg[0],&rLen,2);
				pNc->AllocPerSocketSndQue(pc,mesg,rLen);
			}
			if(pt2==1){
				pc=(Ptype_session)mc->party.mem3;
				if(pc==NULL) return 0;
				rLen=2;
				mesg[rLen] = PK_LEVELUP;//2
				rLen+=1;
				mesg[rLen] = pc->level;//4
				rLen+=1;
				memcpy(&mesg[rLen],&nEnd,2);
				rLen+=2;
				memcpy(&mesg[0],&rLen,2);
				pNc->AllocPerSocketSndQue(pc,mesg,rLen);
			}

		}else{
			EnterCriticalSection(&pNc->m_cs);
			c->coin += coin;
			c->exp +=exp;
			wasLVup=pNc->m_database.LevelUpCheck(c);//check lvup 0:not lvup 1:lvup
			LeaveCriticalSection(&pNc->m_cs);

			if(wasLVup==1){//status recal
				rLen=2;
				mesg[rLen] = PK_LEVELUP;//2
				rLen+=1;
				mesg[rLen] = c->level;//4
				rLen+=1;
				memcpy(&mesg[rLen],&nEnd,2);
				rLen+=2;
				memcpy(&mesg[0],&rLen,2);
				pNc->AllocPerSocketSndQue(c,mesg,rLen);
			}
		}
	}
	return TRUE;
}


BOOL Npcs::NpcDropItem(type_npc * npc, WORD userNo,PVOID param)
{
	DWORD ItmNo;
	int tmp=0,cnt=0,loopCnt=0,i;
	char data[128];
	WORD dLen=2,nEnd = PEND;
	void *m_pMemBlock;
	
	cNetwork* pNc=(cNetwork*)param;

	tmp = (((DWORD)rand())^((DWORD)time(NULL)))%100;//10%̊mŃACeQl
	if(tmp<10) loopCnt=2;
	else loopCnt=1;

	data[dLen] = PK_OBJ_ADD;
	dLen+=1;
	data[dLen] = T_ITEM;
	dLen+=1;
//	data[dLen]= 1;//cnt
	dLen+=1;

	for(i=0;i<12;i++){
		tmp = (((DWORD)rand())^((DWORD)time(NULL)))%100;
		if(npc->div==1){//npc
			if(def_npc[npc->npc_id].rate[i]>=tmp){
				if(def_npc[npc->npc_id].item[i]==0) continue;
				cnt+=1;
				//const int AllocationSize=sizeof(type_itemLst_field); // ̑傫 
				m_pMemBlock=VirtualAlloc(NULL,sizeof(type_itemLst_field),MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
				assert(m_pMemBlock);
				type_itemLst_field * temp=reinterpret_cast<type_itemLst_field*>(m_pMemBlock);

				temp->rmFcnt	=0;
				temp->rmHcnt	=0;

				EnterCriticalSection(&pNc->m_database.m_Item.i_cs);
				temp->item_idx_cnt=pNc->m_database.m_Item.ItemReturnDefaultCount(def_npc[npc->npc_id].item[i]);
				if(temp->item_idx_cnt==0){
					VirtualFree(temp,0,MEM_RELEASE);
					LeaveCriticalSection(&pNc->m_database.m_Item.i_cs);
					continue;
				}

				ItmNo =  pNc->m_database.m_Item.ReturnNullItemIndex();//CfbNXo
				pNc->m_database.m_Item.SetItemIndex(ItmNo);
				temp->idx		=ItmNo;
				pNc->m_database.m_Item.ItemAddSect(npc->ARx,npc->ARy,temp);
				temp->x=npc->x;
				temp->y=npc->y;
				temp->item_idx=def_npc[npc->npc_id].item[i];
				LeaveCriticalSection(&pNc->m_database.m_Item.i_cs);

				memcpy(&data[dLen],&temp->idx,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->x,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->y,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->item_idx,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->item_idx_cnt,2);
				dLen+=2;
			}
		}else{//monster
			if(def_mon[npc->npc_id].rate[i]>=tmp){
				if(def_mon[npc->npc_id].item[i]==0) continue;
				cnt+=1;
				m_pMemBlock=VirtualAlloc(NULL,sizeof(type_itemLst_field),MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
				assert(m_pMemBlock);
				type_itemLst_field * temp=reinterpret_cast<type_itemLst_field*>(m_pMemBlock);

				temp->rmFcnt	=0;
				temp->rmHcnt	=0;

				EnterCriticalSection(&pNc->m_database.m_Item.i_cs);
				temp->item_idx_cnt=pNc->m_database.m_Item.ItemReturnDefaultCount(def_npc[npc->npc_id].item[i]);
				if(temp->item_idx_cnt==0){
					VirtualFree(temp,0,MEM_RELEASE);
					LeaveCriticalSection(&pNc->m_database.m_Item.i_cs);
					continue;
				}
				ItmNo =  pNc->m_database.m_Item.ReturnNullItemIndex();//CfbNXo
				pNc->m_database.m_Item.SetItemIndex(ItmNo);
				temp->idx		=ItmNo;
				pNc->m_database.m_Item.ItemAddSect(npc->ARx,npc->ARy,temp);
				temp->x=npc->x;
				temp->y=npc->y;
				temp->item_idx=def_mon[npc->npc_id].item[i];
				LeaveCriticalSection(&pNc->m_database.m_Item.i_cs);

				memcpy(&data[dLen],&temp->idx,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->x,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->y,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->item_idx,2);
				dLen+=2;
				memcpy(&data[dLen],&temp->item_idx_cnt,2);
				dLen+=2;
			}
		}
		if(cnt==loopCnt) break;
	}
		data[4]= cnt;//cnt
		memcpy(&data[dLen],&nEnd,2);
		dLen+=2;
		memcpy(&data[0],&dLen,2);
		pNc->AllocPerSocketSndQueSectorAll(npc->ARx,npc->ARy,data,dLen,NULL);
	return TRUE;
}


void Npcs::NpcSkill1(Ptype_session c, PVOID param, WORD pwr, WORD xx, WORD yy, char * gDat){

	int i,j,x,y,Ax,Ay;
	type_objlist  const * const * tmp_objlist;
	void * ntmp_npc,* npc;
	type_npc * tmp_npc;
	short Len=1,dist,cnt=0,range=4,wasLVup=0,rLen,exp=0,coin=0,result=0;
	char mesg[32];
	Ptype_session pc,mc;
	WORD nEnd = PEND;
	BOOL pt1=FALSE,pt2=FALSE,pt0=FALSE;

	cNetwork* pNc=(cNetwork*)param;

	Ax	=  xx/S_UNITSIZE;
	Ay	=  yy/S_UNITSIZE;
	if(Ax>=32||Ay>=32) return;

	EnterCriticalSection(&n_cs);
	for (i=3;i>0;i--) {
		x = Ax -i+2;
		if(x<0 || x>S_WIDTH-1) continue;

		for(j=3;j>0;j--){
			y = Ay -j+2;
			if(y<0||y>S_WIDTH-1) continue;

			for(npc=voidNpcListGetFirst(&tmp_objlist,x,y); npc; npc=ntmp_npc)
			{
				tmp_npc = (type_npc *)npc;
				ntmp_npc = voidNpcListGetNext(&tmp_objlist);
				if(tmp_npc->div==1) continue;//npc continue;
				if(tmp_npc->status==S_DIE) continue;
				dist = NpcReturnDist(xx,yy,tmp_npc->npc_id);
				if(range>=dist&&dist!=-1){
					cnt+=1;
					gDat[Len]=2;
					Len+=1;
					memcpy(&gDat[Len],&tmp_npc->npc_id,2);
					Len+=2;
					tmp_npc->HP-=pwr;
					if(tmp_npc->HP<=0){
						result=1;//monster die
						tmp_npc->HP=0;
						tmp_npc->targetNO = 0;
						tmp_npc->targetChr = NULL;
						tmp_npc->status = S_DIE;
						coin += tmp_npc->level*10;
						exp += tmp_npc->EXP;

					}else{
						tmp_npc->targetNO = c->userNo;
						tmp_npc->targetChr = c;
						tmp_npc->mvstatus=0;
						tmp_npc->status = S_FIGHT;
					}
					memcpy(&gDat[Len],&tmp_npc->HP,2);
					Len+=2;
				}
			}
		}
	}
	LeaveCriticalSection(&n_cs);

	if(c->party.flag==1){//p[eB[olVFA..
		if(c->party.ison1==2){//p[eB̂Ƃ
			coin = coin/c->party.cnt;
			exp = exp/c->party.cnt;
			mc=c;
		}else{
			mc=(Ptype_session)c->party.master;
			if(mc==NULL) return;
			coin = coin/mc->party.cnt;
			exp = exp/mc->party.cnt;
		}
		EnterCriticalSection(&pNc->m_cs);
		mc->coin+= coin;
		mc->exp +=exp;
		pt0=pNc->m_database.LevelUpCheck(mc);

		if(mc->party.ison2==1){
			pc=(Ptype_session)mc->party.mem2;
			if(pc==NULL) return;
			pc->coin+= coin;
			pc->exp +=exp;
			pt1=pNc->m_database.LevelUpCheck(pc);
		}
		if(mc->party.ison3==1){
			pc=(Ptype_session)mc->party.mem3;
			if(pc==NULL) return;
			pc->coin+= coin;
			pc->exp +=exp;
			pt2=pNc->m_database.LevelUpCheck(pc);//levelup check
		}
		LeaveCriticalSection(&pNc->m_cs);

		if(pt0==TRUE){
			rLen=2;
			mesg[rLen] = PK_LEVELUP;//2
			rLen+=1;
			mesg[rLen] = mc->level;//4
			rLen+=1;
			memcpy(&mesg[rLen],&nEnd,2);
			rLen+=2;
			memcpy(&mesg[0],&rLen,2);
			pNc->AllocPerSocketSndQue(mc,mesg,rLen);
		}
		if(pt1==TRUE){
			pc=(Ptype_session)mc->party.mem2;
			if(pc==NULL) return;
			rLen=2;
			mesg[rLen] = PK_LEVELUP;//2
			rLen+=1;
			mesg[rLen] = pc->level;//4
			rLen+=1;
			memcpy(&mesg[rLen],&nEnd,2);
			rLen+=2;
			memcpy(&mesg[0],&rLen,2);
			pNc->AllocPerSocketSndQue(pc,mesg,rLen);
		}
		if(pt2==TRUE){
			pc=(Ptype_session)mc->party.mem3;
			if(pc==NULL) return;
			rLen=2;
			mesg[rLen] = PK_LEVELUP;//2
			rLen+=1;
			mesg[rLen] = pc->level;//4
			rLen+=1;
			memcpy(&mesg[rLen],&nEnd,2);
			rLen+=2;
			memcpy(&mesg[0],&rLen,2);
			pNc->AllocPerSocketSndQue(pc,mesg,rLen);
		}

	}else{
		EnterCriticalSection(&pNc->m_cs);
		c->coin += coin;
		c->exp +=exp;
		wasLVup=pNc->m_database.LevelUpCheck(c);//check lvup 0:not lvup 1:lvup
		LeaveCriticalSection(&pNc->m_cs);

		if(wasLVup==TRUE){//status recal
			rLen=2;
			mesg[rLen] = PK_LEVELUP;//2
			rLen+=1;
			mesg[rLen] = c->level;//4
			rLen+=1;
			memcpy(&mesg[rLen],&nEnd,2);
			rLen+=2;
			memcpy(&mesg[0],&rLen,2);
			pNc->AllocPerSocketSndQue(c,mesg,rLen);
		}
	}
	gDat[0]=cnt;
}


void Npcs::NpcRegen(WORD idx,PVOID param)
{
	char retdata[32];
	WORD Len=2,nEnd=PEND,tmpx,tmpy,x=0,y=0;
	type_objlist * * pos;
	type_objlist * tmp;
	int i,j,res,random;

	cNetwork* pNc=(cNetwork*)param;
	
	random = (((unsigned int)rand())^((unsigned int)time(NULL)))%4;
	npcArray[idx]->x=npcArray[idx]->Gx+random;
	npcArray[idx]->y=npcArray[idx]->Gy+random;

	for(i=1,j=0;i<8;i++,j++){
		res=i%2;
		if(res==1){
			npcArray[idx]->x+=i;
			npcArray[idx]->y+=j;
		}else{
			npcArray[idx]->x-=i;
			npcArray[idx]->y-=j;
		}
		res=pNc->m_database.m_Map.MapIsGo(npcArray[idx]->x,npcArray[idx]->y);
		if(res==0){
			break;
			res=-1;
		}
	}
	if(res==-1){
		npcArray[idx]->x=npcArray[idx]->Gx;
		npcArray[idx]->y=npcArray[idx]->Gy;
	}

	tmpx = npcArray[idx]->x/S_UNITSIZE;//regen ɂȂZN^̃ZN^W炩ߋ߂Ă...
	tmpy = npcArray[idx]->y/S_UNITSIZE;

	npcArray[idx]->status = S_STAND;
	npcArray[idx]->HP = npcArray[idx]->tHP;

	if(tmpx!=npcArray[idx]->ARx || tmpy!=npcArray[idx]->ARy){

		if (!npcArray[idx]) return;

		if(mapNpcArray[x][y].objL==NULL)	return;
		pos =  m_obj.find_node_objlist(&(mapNpcArray[x][y].objL),npcArray[idx]);
		if(pos==NULL) return;
		tmp = m_obj.pop_data(pos);

		if (!tmp) return;

		m_obj.insert_node_objlist(&(mapNpcArray[tmpx][tmpy].objL), tmp);
		npcArray[idx]->ARx = tmpx;
		npcArray[idx]->ARy = tmpy;
	}
	npcArray[idx]->BSx = tmpx;
	npcArray[idx]->BSy = tmpy;

	retdata[Len] = PK_OBJ_ADD;				//2
	Len+=1;
	retdata[Len] = T_NPC;//obj_type : NPC	//3
	Len+=1;
	retdata[Len] = 1;				//4
	Len+=1;
	retdata[Len] = npcArray[idx]->div;//X^[ npc
	Len+=1;
	retdata[Len] = npcArray[idx]->gtype;//ރ^Cv
	Len+=1;
	memcpy(&retdata[Len],&npcArray[idx]->npc_id,2);
	Len+=2;
	memcpy(&retdata[Len],&npcArray[idx]->level,2);
	Len+=2;
	memcpy(&retdata[Len],&npcArray[idx]->tHP,2);
	Len+=2;
	memcpy(&retdata[Len],&npcArray[idx]->HP,2);
	Len+=2;
	memcpy(&retdata[Len],&npcArray[idx]->AP,2);
	Len+=2;
	retdata[Len] = S_REGEN;
	Len+=1;
	retdata[Len] = npcArray[idx]->DirLoc;
	Len+=1;
	memcpy(&retdata[Len],&npcArray[idx]->x,2);
	Len+=2;
	memcpy(&retdata[Len],&npcArray[idx]->y,2);
	Len+=2;
	memcpy(&retdata[Len],&nEnd,2);
	Len+=2;
	memcpy(&retdata[0],&Len,2);
	pNc->AllocPerSocketSndQueSectorAll(npcArray[idx]->ARx, npcArray[idx]->ARy, retdata, Len, NULL);
}


void Npcs::NpcAttackChr(Ptype_session chr, WORD idx,PVOID param){

	short DaMaGe,DIRx,DIRy,HP;
	char mesg[64];
	WORD rLen=2,nEnd=PEND;

	if(idx>=_MAX_MONSTER_NO) return;
	if(chr==NULL){
		npcArray[idx]->status=S_STAND;
		npcArray[idx]->dx = npcArray[idx]->Gx;
		npcArray[idx]->dy = npcArray[idx]->Gy;
		npcArray[idx]->targetChr=NULL;
		npcArray[idx]->tgFlag= 0;
		return;
	}
	
	cNetwork* pNc=(cNetwork*)param;

	if(npcArray[idx]->status==S_DIE) return;
	if(chr->userStat == S_DIE){
		npcArray[idx]->status=S_STAND;
		npcArray[idx]->dx = npcArray[idx]->Gx;
		npcArray[idx]->dy = npcArray[idx]->Gy;
		npcArray[idx]->targetChr=NULL;
		npcArray[idx]->tgFlag= 0;
		return;
	}
	DIRx = npcArray[idx]->x - chr->Cx;
	DIRy = npcArray[idx]->y - chr->Cy;

	if(DIRx==0 && DIRy<0) npcArray[idx]->DirLoc= 4;			// 12̕
	else if(DIRx<0  && DIRy<0) npcArray[idx]->DirLoc= 3;	// 1 ̕
	else if(DIRx<0 && DIRy==0) npcArray[idx]->DirLoc= 2;	// 3 ̕
	else if(DIRx<0  && DIRy>0) npcArray[idx]->DirLoc= 1;	// 5 ̕
	else if(DIRx==0 && DIRy>0) npcArray[idx]->DirLoc= 0;	// 6 ̕
	else if(DIRx>0  && DIRy>0) npcArray[idx]->DirLoc= 7;	// 7 ̕
	else if(DIRx>0  && DIRy==0) npcArray[idx]->DirLoc= 6;	// 9 ̕
	else if(DIRx>0  && DIRy<0) npcArray[idx]->DirLoc= 5;	// 11̕
	LeaveCriticalSection(&n_cs);

	DaMaGe=npcArray[idx]->AP - chr->defence;
	if(DaMaGe<0) DaMaGe=0;
	HP = chr->hp_c - DaMaGe;
	if(HP<0) HP=0;

	mesg[rLen] = PK_OBJ_UPDATE_ACT;//2
	rLen+=1;
	mesg[rLen] = T_NPC;//obj_type:0 - user
	rLen+=1;
	mesg[rLen] = 1;//count
	rLen+=1;
	mesg[rLen] = npcArray[idx]->div;//count
	rLen+=1;
	memcpy(&mesg[rLen],&npcArray[idx]->npc_id,2);//8
	rLen+=2;
	mesg[rLen]=S_FIGHT;
	rLen+=1;
	mesg[rLen]=npcArray[idx]->DirLoc;
	rLen+=1;
	mesg[rLen]=T_USER;//target type
	rLen+=1;
	memcpy(&mesg[rLen],&chr->userNo,2);//target id no.
	rLen+=2;
	memcpy(&mesg[rLen],&HP,2);//target HP
	rLen+=2;
	memcpy(&mesg[rLen],&nEnd,2);
	rLen+=2;
	memcpy(&mesg[0],&rLen,2);
	pNc->AllocPerSocketSndQueSectorAll(chr->Ax, chr->Ay, mesg, rLen,NULL);//arg5 NULLł闝R ...Ȃ̂..

	EnterCriticalSection(&pNc->m_cs);
	if(HP==0){//chr die
		chr->userStat = S_DIE;
		chr->hp_c	  = chr->hp_m/10;
		LeaveCriticalSection(&pNc->m_cs);
//		MonsterChrDie(idx,chr);//m点..
		EnterCriticalSection(&n_cs);

		npcArray[idx]->status=S_STAND;
		npcArray[idx]->targetChr=NULL;
		npcArray[idx]->tgFlag= 0;

		return;
	}else chr->hp_c=HP;
	LeaveCriticalSection(&pNc->m_cs);
	EnterCriticalSection(&n_cs);
	npcArray[idx]->tgFlag= 1;
}


type_npc * Npcs::NpcReturnFight(WORD idx,PVOID param){//ݐĂnpcT

	int i,j,x,y;
	type_objlist  const * const * tmp_objlist;
	void * ntmp_npc,* npc;
	type_npc * tmp_npc;
	short Len;

	cNetwork* pNc=(cNetwork*)param;

	for (i=3;i>0;i--) {
		x = npcArray[idx]->ARx -i+2;
		if(x<0 || x>S_WIDTH-1) continue;

		for(j=3;j>0;j--){
			y = npcArray[idx]->ARy -j+2;
			if(y<0||y>S_WIDTH-1) continue;

			for(npc=voidNpcListGetFirst(&tmp_objlist,x,y); npc; npc=ntmp_npc)
			{
				tmp_npc = (type_npc *)npc;
				ntmp_npc = voidNpcListGetNext(&tmp_objlist);
				if(tmp_npc->status==S_DIE) continue;
				if(tmp_npc->tgFlag==1){
					Len = pNc->m_database.m_Map.MapReturnDist(npcArray[idx]->x, npcArray[idx]->y, tmp_npc->x,tmp_npc->y);
					if(npcArray[idx]->Sight>=Len) return tmp_npc;
				}
			}
		}
	}
	return NULL;
}


void Npcs::NpcMoveSet(WORD idx,PVOID param)
{
	int res=0;

	if(npcArray[idx]->move_F_cnt>=NPC_MV_FRAME){//ŏ̃t[path find ⓮̂߂Ă݂@Փ˃`FbN..

		npcArray[idx]->move_F_cnt=0;

		res=NpcMoveOne(npcArray[idx],param);//JEgςɂȂPR}

		if(npcArray[idx]->mvstatus==0){//͂߂ĐڂƂ
			if(res==1){//
				if(npcArray[idx]->x == npcArray[idx]->dx
				&&npcArray[idx]->y == npcArray[idx]->dy){//ړIn

					if(npcArray[idx]->tgFlag==0) npcArray[idx]->status= S_STAND;
					else npcArray[idx]->status= S_FIGHT;
					npcArray[idx]->mvstatus=0;//ړ..
				}else npcArray[idx]->mvstatus=1;//ړ..
			}
		}else{
			if(res==0){//ZN^ړs
				npcArray[idx]->status=S_STAND;
				npcArray[idx]->mvstatus=0;//ړ..
			}else{//ړ..
				if(npcArray[idx]->x == npcArray[idx]->dx && npcArray[idx]->y == npcArray[idx]->dy){
					if(npcArray[idx]->tgFlag==0) npcArray[idx]->status= S_STAND;
					else npcArray[idx]->status= S_FIGHT;
					npcArray[idx]->mvstatus=0;//ړ..
				}
			}
		}

	}else npcArray[idx]->move_F_cnt++;
}


BOOL Npcs::NpcMoveOne(type_npc * npc,PVOID param){//PR}ړ

	type_objlist * * pos;
	type_objlist * tmp;
	short tmpx,tmpy;
	WORD nEnd=PEND,rLen=2;
	char mesg[64];
	short DIRx,DIRy;

	cNetwork* pNc=(cNetwork*)param;

	if(npc->x==npc->dx&&npc->y==npc->dy){
		return TRUE;
	}

	DIRx = npc->x - npc->dx;
	DIRy = npc->y - npc->dy;
	tmpx = npc->x;
	tmpy = npc->y;

	if(DIRx==0 && DIRy<0){
		npc->DirLoc= 4;	// 12̕({ɍ)
		tmpy +=1;
	}else if(DIRx<0  && DIRy<0){
		npc->DirLoc= 3;	// 1 ̕
	 	tmpx +=1;
		tmpy +=1;
	}else if(DIRx<0 && DIRy==0){
		npc->DirLoc= 2;	// 3 ̕
	 	tmpx +=1;
	}else if(DIRx<0  && DIRy>0){
		npc->DirLoc= 1;	// 5 ̕
	 	tmpx +=1;
		tmpy -=1;
	}else if(DIRx==0 && DIRy>0){
		npc->DirLoc= 0;	// 6 ̕
		tmpy -=1;
	}else if(DIRx>0  && DIRy>0){
		npc->DirLoc= 7;	// 7 ̕
	 	tmpx -=1 ;
		tmpy -=1;
	}else if(DIRx>0  && DIRy==0){
		npc->DirLoc= 6;	// 9 ̕
	 	tmpx -=1;
	}else if(DIRx>0  && DIRy<0){
		npc->DirLoc= 5;	// 11̕
	 	tmpx -=1;
		tmpy +=1;
	}

	//̕ɓē邱Ƃł.
if(npc->npc_id==17) printf("%d npc %d,%d -> %d,%d PR}ړ\n",npc->npc_id,npc->x,npc->y,tmpx,tmpy);
	if(tmpx<0) tmpx=0;
	if(tmpy<0) tmpy=0;
	npc->x=tmpx;
	npc->y=tmpy;
	if(npc->x>=M_SIZE_X||npc->y>=M_SIZE_X){
		npc->status= S_STAND;
		npc->x=npc->Gx;
		npc->y=npc->Gy;
	}


	if(npc->mvstatus==0){//0Ȃ͂߂ē̂ŃpPbgMȂ΂ȂȂ.

		mesg[rLen] = PK_OBJ_UPDATE_ACT;//2
		rLen+=1;
		mesg[rLen] = T_NPC;//obj_type:0 - user
		rLen+=1;
		mesg[rLen] = 1;//count
		rLen+=1;
		mesg[rLen] = npc->div;
		rLen+=1;
		memcpy(&mesg[rLen],&npc->npc_id,2);//8
		rLen+=2;
		mesg[rLen]=S_MOVE;
		rLen+=1;
		mesg[rLen]=npc->DirLoc;
		rLen+=1;
		mesg[rLen]=npc->speed;
		rLen+=1;
		memcpy(&mesg[rLen],&npc->x,2);
		rLen+=2;
		memcpy(&mesg[rLen],&npc->y,2);
		rLen+=2;
		memcpy(&mesg[rLen],&npc->dx,2);
		rLen+=2;
		memcpy(&mesg[rLen],&npc->dy,2);
		rLen+=2;
		memcpy(&mesg[rLen],&nEnd,2);
		rLen+=2;
		memcpy(&mesg[0],&rLen,2);
		pNc->AllocPerSocketSndQueSectorAll(npc->ARx, npc->ARy,mesg,rLen,NULL);//[UɑM..
		npc->mvstatus=1;
	}

	tmpx = npc->x/S_UNITSIZE;
	tmpy = npc->y/S_UNITSIZE;

	if(tmpx!=npc->ARx || tmpy!=npc->ARy){

		if (!npc){
			printf("npc pointer null \n");
			return FALSE;
		}

		if(mapNpcArray[npc->ARx][npc->ARy].objL==NULL){
			printf("mapArray NULL list in map_char_mv:%d,%d=:%d\n",npc->ARx,npc->ARy,npc->npc_id);
			return FALSE;
		}

		pos =  m_obj.find_node_objlist(&(mapNpcArray[npc->ARx][npc->ARy].objL),npc);

		if(pos==NULL){
			printf("pos not found\n");
			return FALSE;
		}

		tmp = m_obj.pop_data(pos);

		if (!tmp){
			printf("no pop \n");
			return FALSE;
		}
		m_obj.insert_node_objlist(&(mapNpcArray[tmpx][tmpy].objL), tmp);

		npc->ARx = tmpx;
		npc->ARy = tmpy;

		NpcMoveAddInfo(npc, param);//npc̃ZN^ړŐVZN^ɏ`B..
	}
	return TRUE;
}


void Npcs::NpcMoveAddInfo(type_npc * npc,PVOID param){

	int x,y;
	int ax,ay,i;
	char udata[128];
	unsigned short	nEnd=PEND,dLen=2;
	
	cNetwork* pNc=(cNetwork*)param;

	udata[dLen] = PK_OBJ_ADD;
	dLen+=1;
	udata[dLen] = T_NPC;//NPC
	dLen+=1;
	udata[dLen] = 1;
	dLen+=1;
	udata[dLen] = npc->div;
	dLen+=1;
	udata[dLen] = npc->gtype;
	dLen+=1;
	memcpy(&udata[dLen],&npc->npc_id,2);
	dLen+=2;
	memcpy(&udata[dLen],&npc->level,2);
	dLen+=2;
	memcpy(&udata[dLen],&npc->tHP,2);
	dLen+=2;
	memcpy(&udata[dLen],&npc->HP,2);
	dLen+=2;
	udata[dLen] = npc->status;
	dLen+=1;
	udata[dLen] = npc->DirLoc;
	dLen+=1;
	if(npc->status==S_STAND){//stand
		memcpy(&udata[dLen],&npc->x,2);
		dLen+=2;
		memcpy(&udata[dLen],&npc->y,2);
		dLen+=2;
	}else if(npc->status==S_MOVE){
		udata[dLen] = npc->DirLoc;
		dLen+=1;
		udata[dLen] = npc->speed;
		dLen+=1;
		memcpy(&udata[dLen],&npc->x,2);
		dLen+=2;
		memcpy(&udata[dLen],&npc->y,2);
		dLen+=2;
		memcpy(&udata[dLen],&npc->dx,2);
		dLen+=2;
		memcpy(&udata[dLen],&npc->dy,2);
		dLen+=2;
	}else if(npc->status==S_FIGHT){
		memcpy(&udata[dLen],&npc->x,2);
		dLen+=2;
		memcpy(&udata[dLen],&npc->y,2);
		dLen+=2;
		memcpy(&udata[dLen],&npc->targetNO,2);
		dLen+=2;
	}
	memcpy(&udata[dLen],&nEnd,2);
	dLen+=2;
	memcpy(&udata[0],&dLen,2);

	x = npc->BSx - npc->ARx;
	y = npc->BSy - npc->ARy;
	if(x==0 && y<0){// 12̕	

		for(i=3;i>0;i--){
			ax = npc->ARx -i+2;
			ay = npc->ARy +1;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop
	}else if(x<0  && y<0){// 1 ̕	?

		for(i=3;i>0;i--){
			ax = npc->ARx -i+2;
			ay = npc->ARy +1;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop

		for(i=0;i<2;i++){
			ax = npc->ARx +1;
			ay = npc->ARy -i;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop

	}else if(x<0 && y==0){// 3 ̕	

		for(i=3;i>0;i--){
			ax = npc->ARx +1;
			ay = npc->ARy -i+2;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop
	}else if(x<0  && y>0){// 4 ̕	?

		for(i=3;i>0;i--){
			ax = npc->ARx -i+2;
			ay = npc->ARy -1;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop

		for(i=0;i<2;i++){
			ax = npc->ARx +1;
			ay = npc->ARy +i;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop

	}else if(x==0 && y>0){// 6 ̕	

		for(i=3;i>0;i--){
			ax = npc->ARx -i+2;
			ay = npc->ARy -1;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop
	}else if(x>0  && y>0){// 7 ̕	?

		for(i=3;i>0;i--){
			ax = npc->ARx -i+2;
			ay = npc->ARy -1;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop

		for(i=0;i<2;i++){
			ax = npc->ARx -1;
			ay = npc->ARy +i;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop


	}else if(x>0  && y==0){// 9 ̕	

		for(i=3;i>0;i--){

			ax = npc->ARx -1;
			ay = npc->ARy -i+2;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop
	}else if(x>0  && y<0){// 10̕	?

		for(i=3;i>0;i--){
			ax = npc->ARx -i+2;
			ay = npc->ARy +1;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop

		for(i=0;i<2;i++){
			ax = npc->ARx -1;
			ay = npc->ARy -i;

			if(ax>=0 && ax<S_WIDTH && ay>=0 && ay<S_WIDTH)
				pNc->m_database.m_Map.MapSecDataSnd(ax, ay, udata, dLen,param);
			else continue;
		}//end for loop

	}
	npc->BSx = npc->ARx;
	npc->BSy = npc->ARy;
}
